﻿//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "ficheprincipale.h"
//---------------------------------------------------------------------------
/*#pragma argsused
#pragma package(smart_init) */
//---------------------------------------------------------------------------
/*
*****************************************************************************
** Flyonchess                                                              **
** Auteur : Florent HUGUES                                                 **
**                                                                         **
** Licence : LGPL 2.1                                                      **
** Version 0.0.1.0                                                         **
*****************************************************************************
*/
UnicodeString ReineBlanc;
UnicodeString RoiBlanc;
UnicodeString TourBlanc;
UnicodeString CavalierBlanc;
UnicodeString FouBlanc;
UnicodeString PionBlanc;
UnicodeString ReineNoir;
UnicodeString RoiNoir;
UnicodeString TourNoir;
UnicodeString CavalierNoir;
UnicodeString FouNoir;
UnicodeString PionNoir;
UnicodeString Changementstr;
//---------------------------------------------------------------------------
int __fastcall Echiquier::EstEchec(int coul)
{
roi *temproi;
for (int i = 0; i < 2; i++)
    {
    temproi = (roi *)(Proi + i);
    if (temproi->Couleur() == coul)
       {
       return CaseEchec(temproi->PositionX(), temproi->PositionY(), coul);
       }
    }
return 0;
}
//---------------------------------------------------------------------------
int __fastcall Echiquier::CaseEchec(int x, int y, int coul) // 0 = rien, 1 = échec
{
pion *temppion;
cavalier *tempcavalier;
tour *temptour;
fou *tempfou;
reine *tempreine;
roi *temproi;
roi *temproi2;
carreau * tempcarreau;
for (int i = 0; i < 2; i++)
    {
    temproi2 = (roi *)(Proi + i);
    if (temproi2->Couleur() != coul)
       {
       if (temproi2->PositionX() - x <= 1 && temproi2->PositionX() - x >= -1 && temproi2->PositionY() - y <= 1 && temproi2->PositionY() - y >= -1)
          {
          return 1;
          }
       }
    else {
         temproi = temproi2;
         }
    }
int ori; //déduction de l'orientation du déplacement en fonction du sens et de la couleur
if (coul == noir) // on s'en sert comme multiplicateur pour ajouter ou soustraire.
   {
   if (this->sens == 0)
      {
      ori = 1;
      }
   else {
        ori = -1;
        }
   }
else {
     if (this->sens == 0)
        {
        ori = -1;
        }
     else {
          ori = 1;
          }
     }
for (int i = 0; i < 16; i++)
    {
    temppion = (pion *)(Ppion + i);
    if (temppion != NULL)
       {
       if (temppion->Actif() == true)
		  {
		  if (temppion->Couleur() != coul && (temppion->PositionX() != x || temppion->PositionY() != y))
             {
             if ((temppion->PositionX() - x == 1 || temppion->PositionX() - x == -1) && temppion->PositionY() - y == -ori)
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbcavalier; i++)
    {
    tempcavalier = (cavalier *)(Pcavalier + i);
    if (tempcavalier != NULL)
       {
       if (tempcavalier->Actif() == true)
		  {
		  if (tempcavalier->Couleur() != coul && (tempcavalier->PositionX() != x || tempcavalier->PositionY() != y))
			 {

             if ((tempcavalier->PositionX() - x == 1 || tempcavalier->PositionX() - x == -1) && (tempcavalier->PositionY() - y == 2 || tempcavalier->PositionY() - y == -2))
                {
                return 1;
                }
             if ((tempcavalier->PositionX() - x == 2 || tempcavalier->PositionX() - x == -2) && (tempcavalier->PositionY() - y == 1 || tempcavalier->PositionY() - y == -1))
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbtour; i++)
    {
    temptour = (tour *)(Ptour + i);
    if (temptour != NULL)
       {
       if (temptour->Actif() == true)
          {
		  if (temptour->Couleur() != coul && (temptour->PositionX() != x || temptour->PositionY() != y))
			 {
             if (temptour->PositionX() == x || temptour->PositionY() == y)
                {
                bool echectemp = true;
                int tempdep;
                if (temptour->PositionX() == x)           // Même ligne
                   {
                   tempdep = y - temptour->PositionY();   // Calcule de l'écart entre la pièce et la case
                   }
                else {                                     // Même colonne
                     tempdep = x - temptour->PositionX(); // Calcule de l'écart entre la pièce et la case
                     }
                int i;
                if (tempdep < 0)
                   {
                   i = 1;
                   }
                else {
                     i = -1;
                     }
                while (-tempdep != i)
                      {
                      if (temptour->PositionX() == x)
                         {
                         tempcarreau = (carreau *)(Pcarreau + x - 1 + ((y + i - 1) * 8));
                         }
                      else {
                           tempcarreau = (carreau *)(Pcarreau + x + i - 1 + ((y - 1) * 8));
                           }
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         echectemp = false;
                         break;
                         }
                      if (tempdep < 0)
                         {
                         i++;
                         }
                      else {
                           i--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
for (int i = 0; i < Nbfou; i++)
    {
    tempfou = (fou *)(Pfou + i);
    if (tempfou != NULL)
       {
       if (tempfou->Actif() == true)
          {
		  if (tempfou->Couleur() != coul && (tempfou->PositionX() != x || tempfou->PositionY() != y))
             {
             int xfou, yfou;
             xfou = x - tempfou->PositionX();
             yfou = y - tempfou->PositionY();
             if (xfou == yfou || xfou == -yfou)
                {
                bool echectemp = true;
                while (xfou != 0)
                      {
					  tempcarreau = (carreau *)(Pcarreau + tempfou->PositionX() + xfou - 1 + ((tempfou->PositionY() + yfou - 1) * 8));
                      if ((tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi) && !(tempfou->PositionX() + xfou == x && tempfou->PositionY() + yfou == y))
                         {
                         echectemp = false;
                         break;
                         }
                      if (xfou < 0)
                         {
                         xfou++;
                         }
                      else {
                           xfou--;
                           }
                      if (yfou < 0)
                         {
                         yfou++;
                         }
                      else {
                           yfou--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
for (int i = 0; i < Nbreine; i++)
    {
    tempreine = (reine *)(Preine + i);
    if (tempreine != NULL)
	   {
	   if (tempreine->Actif() == true)
		  {
		  if (tempreine->Couleur() != coul && (tempreine->PositionX() != x || tempreine->PositionY() != y))
			 {
			 int xfou, yfou;
			 xfou = x - tempreine->PositionX();
             yfou = y - tempreine->PositionY();
             if (xfou == yfou || xfou == -yfou)
                {
                bool echectemp = true;
                while (xfou != 0)
                      {
                      tempcarreau = (carreau *)(Pcarreau + tempreine->PositionX() + xfou - 1 + ((tempreine->PositionY() + yfou - 1) * 8));
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi && !(tempreine->PositionX() + xfou == x && tempreine->PositionY() + yfou == y))
                         {
                         echectemp = false;
                         break;
                         }
                      if (xfou < 0)
                         {
                         xfou++;
                         }
                      else {
                           xfou--;
                           }
                      if (yfou < 0)
                         {
                         yfou++;
                         }
                      else {
                           yfou--;
                           }
                      }
				if (echectemp == true)
                   {
                   return 1;
                   }
                }
             if (tempreine->PositionX() == x || tempreine->PositionY() == y)
                {
                bool echectemp = true;
                int tempdep;
                if (tempreine->PositionX() == x)           // Même ligne
                   {
                   tempdep = y - tempreine->PositionY();   // Calcule de l'écart entre la pièce et la case
                   }
                else {                                     // Même colonne
                     tempdep = x - tempreine->PositionX(); // Calcule de l'écart entre la pièce et la case
                     }
                int i;
                if (tempdep < 0)
                   {
                   i = 1;
                   }
                else {
                     i = -1;
                     }
                while (-tempdep != i)
                      {
                      if (tempreine->PositionX() == x)
                         {
                         tempcarreau = (carreau *)(Pcarreau + x - 1 + ((y + i - 1) * 8));
                         }
                      else {
                           tempcarreau = (carreau *)(Pcarreau + x + i - 1 + ((y - 1) * 8));
                           }
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
						 {
                         echectemp = false;
                         break;
                         }
                      if (tempdep < 0)
                         {
                         i++;
                         }
                      else {
                           i--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
return 0;
}
//---------------------------------------------------------------------------
// La piece est déplacé, vérifier que ne s'auto protège
int __fastcall Echiquier::EstEchec(int pxarrroi, int pyarroi, int coul)
{
pion *temppion;
cavalier *tempcavalier;
tour *temptour;
fou *tempfou;
reine *tempreine;
roi *temproi;
roi *temproi2;
carreau * tempcarreau;
int x = pxarrroi;
int y = pyarroi;
for (int i = 0; i < 2; i++)
    {
    temproi2 = (roi *)(Proi + i);
    if (temproi2->Couleur() != coul)
       {
       if (temproi2->PositionX() - x <= 1 && temproi2->PositionX() - x >= -1 && temproi2->PositionY() - y <= 1 && temproi2->PositionY() - y >= -1)
          {
          return 1;
          }
       }
    else {
         temproi = temproi2;
         }
    }
int ori; //déduction de l'orientation du déplacement en fonction du sens et de la couleur
if (coul == noir) // on s'en sert comme multiplicateur pour ajouter ou soustraire.
   {
   if (this->sens == 0)
      {
      ori = 1;
      }
   else {
        ori = -1;
        }
   }
else {
     if (this->sens == 0)
        {
        ori = -1;
        }
     else {
		  ori = 1;
          }
     }
for (int i = 0; i < 16; i++)
    {
    temppion = (pion *)(Ppion + i);
    if (temppion != NULL)
       {
       if (temppion->Actif() == true)
		  {
		  if (temppion->Couleur() != coul && (temppion->PositionX() != x || temppion->PositionY() != y))
             {
             if ((temppion->PositionX() - x == 1 || temppion->PositionX() - x == -1) && temppion->PositionY() - y == -ori)
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbcavalier; i++)
    {
    tempcavalier = (cavalier *)(Pcavalier + i);
    if (tempcavalier != NULL)
       {
       if (tempcavalier->Actif() == true)
          {
		  if (tempcavalier->Couleur() != coul && (tempcavalier->PositionX() != x || tempcavalier->PositionY() != y))
             {

             if ((tempcavalier->PositionX() - x == 1 || tempcavalier->PositionX() - x == -1) && (tempcavalier->PositionY() - y == 2 || tempcavalier->PositionY() - y == -2))
                {
                return 1;
                }
			 if ((tempcavalier->PositionX() - x == 2 || tempcavalier->PositionX() - x == -2) && (tempcavalier->PositionY() - y == 1 || tempcavalier->PositionY() - y == -1))
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbtour; i++)
    {
    temptour = (tour *)(Ptour + i);
    if (temptour != NULL)
       {
       if (temptour->Actif() == true)
		  {
		  if (temptour->Couleur() != coul && (temptour->PositionX() != x || temptour->PositionY() != y))
             {
             if (temptour->PositionX() == x || temptour->PositionY() == y)
                {
                bool echectemp = true;
                int tempdep;
                if (temptour->PositionX() == x)           // Même ligne
                   {
                   tempdep = y - temptour->PositionY();   // Calcule de l'écart entre la pièce et la case
                   }
                else {                                     // Même colonne
                     tempdep = x - temptour->PositionX(); // Calcule de l'écart entre la pièce et la case
                     }
                int i;
                if (tempdep < 0)
                   {
                   i = 1;
                   }
                else {
					 i = -1;
                     }
                while (-tempdep != i)
                      {
                      if (temptour->PositionX() == x)
                         {
                         tempcarreau = (carreau *)(Pcarreau + x - 1 + ((y + i - 1) * 8));
                         }
                      else {
                           tempcarreau = (carreau *)(Pcarreau + x + i - 1 + ((y - 1) * 8));
                           }
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         echectemp = false;
                         break;
                         }
                      if (tempdep < 0)
                         {
                         i++;
                         }
                      else {
                           i--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
for (int i = 0; i < Nbfou; i++)
	{
    tempfou = (fou *)(Pfou + i);
    if (tempfou != NULL)
       {
       if (tempfou->Actif() == true)
		  {
		  if (tempfou->Couleur() != coul && (tempfou->PositionX() != x || tempfou->PositionY() != y))
             {
             int xfou, yfou;
             xfou = x - tempfou->PositionX();
             yfou = y - tempfou->PositionY();
             if (xfou == yfou || xfou == -yfou)
                {
                bool echectemp = true;
                while (xfou != 0)
                      {
                      tempcarreau = (carreau *)(Pcarreau + tempfou->PositionX() + xfou - 1 + ((tempfou->PositionY() + yfou - 1) * 8));
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         echectemp = false;
                         break;
                         }
                      if (xfou < 0)
                         {
                         xfou++;
                         }
                      else {
                           xfou--;
                           }
                      if (yfou < 0)
                         {
                         yfou++;
                         }
                      else {
						   yfou--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
for (int i = 0; i < Nbreine; i++)
    {
    tempreine = (reine *)(Preine + i);
    if (tempreine != NULL)
       {
       if (tempreine->Actif() == true)
          {
		  if (tempreine->Couleur() != coul && (tempreine->PositionX() != x || tempreine->PositionY() != y))
             {
             int xfou, yfou;
             xfou = x - tempreine->PositionX();
             yfou = y - tempreine->PositionY();
             if (xfou == yfou || xfou == -yfou)
                {
                bool echectemp = true;
                while (xfou != 0)
                      {
                      tempcarreau = (carreau *)(Pcarreau + tempreine->PositionX() + xfou - 1 + ((tempreine->PositionY() + yfou - 1) * 8));
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         echectemp = false;
                         break;
						 }
                      if (xfou < 0)
                         {
                         xfou++;
                         }
                      else {
                           xfou--;
                           }
                      if (yfou < 0)
                         {
                         yfou++;
                         }
                      else {
                           yfou--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             if (tempreine->PositionX() == x || tempreine->PositionY() == y)
                {
                bool echectemp = true;
                int tempdep;
                if (tempreine->PositionX() == x)           // Même ligne
                   {
                   tempdep = y - tempreine->PositionY();   // Calcule de l'écart entre la pièce et la case
                   }
                else {                                     // Même colonne
                     tempdep = x - tempreine->PositionX(); // Calcule de l'écart entre la pièce et la case
                     }
                int i;
                if (tempdep < 0)
				   {
                   i = 1;
                   }
                else {
                     i = -1;
                     }
                while (-tempdep != i)
                      {
                      if (tempreine->PositionX() == x)
                         {
                         tempcarreau = (carreau *)(Pcarreau + x - 1 + ((y + i - 1) * 8));
                         }
                      else {
                           tempcarreau = (carreau *)(Pcarreau + x + i - 1 + ((y - 1) * 8));
                           }
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         echectemp = false;
                         break;
                         }
                      if (tempdep < 0)
                         {
                         i++;
                         }
                      else {
                           i--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
		  }
       }
    }
return 0;
}
//---------------------------------------------------------------------------
int __fastcall Echiquier::EstEchec(int pxdep, int pydep, int pxarr, int pyarr, int coul)
{ // prévision d'échec en cas de déplacement d'une pièce pour déterminer si on en a le droit
pion *temppion;
cavalier *tempcavalier;
tour *temptour;
fou *tempfou;
reine *tempreine;
roi *temproi;
roi *temproi2;
carreau * tempcarreau;
int x = pxarr;
int y = pyarr;
for (int i = 0; i < 2; i++)
    {
    temproi2 = (roi *)(Proi + i);
    if (temproi2->Couleur() == coul)
       {
       temproi = temproi2;
       x = temproi->PositionX();
       y = temproi->PositionY();
       }
	}
for (int i = 0; i < 2; i++)
    {
    temproi2 = (roi *)(Proi + i);
    if (temproi2->Couleur() != coul)
       {
       if (temproi2->PositionX() - x <= 1 && temproi2->PositionX() - x >= -1 && temproi2->PositionY() - y <= 1 && temproi2->PositionY() - y >= -1)
          {
          return 1;
          }
       }
	}
int ori; //déduction de l'orientation du déplacement en fonction du sens et de la couleur
if (coul == noir) // on s'en sert comme multiplicateur pour ajouter ou soustraire.
   {
   if (this->sens == 0)
      {
      ori = 1;
      }
   else {
        ori = -1;
        }
   }
else {
     if (this->sens == 0)
        {
        ori = -1;
        }
     else {
          ori = 1;
          }
     }
for (int i = 0; i < 16; i++)
    {
    temppion = (pion *)(Ppion + i);
    if (temppion != NULL)
       {
	   if (temppion->Actif() == true)
          {
		  if (temppion->Couleur() != coul && (temppion->PositionX() != pxarr || temppion->PositionY() != pyarr))
			 {
			 if ((temppion->PositionX() - x == 1 || temppion->PositionX() - x == -1) && temppion->PositionY() - y == -ori)
				{
				return 1;
				}
			 }
		  }
       }
	}
for (int i = 0; i < Nbcavalier; i++)
    {
    tempcavalier = (cavalier *)(Pcavalier + i);
    if (tempcavalier != NULL)
       {
       if (tempcavalier->Actif() == true)
          {
		  if (tempcavalier->Couleur() != coul && (tempcavalier->PositionX() != pxarr || tempcavalier->PositionY() != pyarr))
             {

             if ((tempcavalier->PositionX() - x == 1 || tempcavalier->PositionX() - x == -1) && (tempcavalier->PositionY() - y == 2 || tempcavalier->PositionY() - y == -2))
                {
                return 1;
                }
             if ((tempcavalier->PositionX() - x == 2 || tempcavalier->PositionX() - x == -2) && (tempcavalier->PositionY() - y == 1 || tempcavalier->PositionY() - y == -1))
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbtour; i++)
    {
    temptour = (tour *)(Ptour + i);
    if (temptour != NULL)
       {
       if (temptour->Actif() == true)
          {
		  if (temptour->Couleur() != coul && (temptour->PositionX() != pxarr || temptour->PositionY() != pyarr))
             {
             if (temptour->PositionX() == x || temptour->PositionY() == y)
                {
                bool echectemp = true;
                int tempdep;
                if (temptour->PositionX() == x)           // Même ligne
                   {
                   tempdep = y - temptour->PositionY();   // Calcule de l'écart entre la pièce et la case
                   }
                else {                                     // Même colonne
                     tempdep = x - temptour->PositionX(); // Calcule de l'écart entre la pièce et la case
                     }
                int i;
                if (tempdep < 0)
                   {
                   i = 1;
                   }
                else {
                     i = -1;
                     }
                while (-tempdep != i)
                      {
                      if (temptour->PositionX() == x)
                         {
                         tempcarreau = (carreau *)(Pcarreau + x - 1 + ((y + i - 1) * 8));
                         }
                      else {
                           tempcarreau = (carreau *)(Pcarreau + x + i - 1 + ((y - 1) * 8));
                           }
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         if (((piece *)tempcarreau->Piece())->PositionX() != pxdep || ((piece *)tempcarreau->Piece())->PositionY() != pydep)
                            {
                            echectemp = false;
                            break;
                            }
                         }
                      else {
                           if (tempcarreau->PositionX() == pxarr && tempcarreau->PositionY() == pyarr)
                              {
                              echectemp = false;
                              break;
                              }
                           }
                      if (tempdep < 0)
                         {
                         i++;
                         }
                      else {
                           i--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
for (int i = 0; i < Nbfou; i++)
    {
    tempfou = (fou *)(Pfou + i);
    if (tempfou != NULL)
       {
       if (tempfou->Actif() == true)
          {
		  if (tempfou->Couleur() != coul && (tempfou->PositionX() != pxarr || tempfou->PositionY() != pyarr))
             {
             int xfou, yfou;
             xfou = x - tempfou->PositionX();
             yfou = y - tempfou->PositionY();
             if (xfou == yfou || xfou == -yfou)
                {
                bool echectemp = true;
                while (xfou != 0)
                      {
                      tempcarreau = (carreau *)(Pcarreau + tempfou->PositionX() + xfou - 1 + ((tempfou->PositionY() + yfou - 1) * 8));
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         if (((piece *)tempcarreau->Piece())->PositionX() != pxdep || ((piece *)tempcarreau->Piece())->PositionY() != pydep)
                            {
                            echectemp = false;
                            break;
                            }
                         }
                      else {
                           if (tempcarreau->PositionX() == pxarr && tempcarreau->PositionY() == pyarr)
                              {
                              echectemp = false;
                              break;
                              }
                           }
                      if (xfou < 0)
                         {
                         xfou++;
                         }
                      else {
                           xfou--;
                           }
                      if (yfou < 0)
                         {
                         yfou++;
                         }
                      else {
                           yfou--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
for (int i = 0; i < Nbreine; i++)
    {
    tempreine = (reine *)(Preine + i);
    if (tempreine != NULL)
       {
       if (tempreine->Actif() == true)
          {
		  if (tempreine->Couleur() != coul && (tempreine->PositionX() != pxarr || tempreine->PositionY() != pyarr))
             {
             int xfou, yfou;
             xfou = x - tempreine->PositionX();
             yfou = y - tempreine->PositionY();
             if (xfou == yfou || xfou == -yfou)
                {
                bool echectemp = true;
                while (xfou != 0)
                      {
                      tempcarreau = (carreau *)(Pcarreau + tempreine->PositionX() + xfou - 1 + ((tempreine->PositionY() + yfou - 1) * 8));
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         if (((piece *)tempcarreau->Piece())->PositionX() != pxdep || ((piece *)tempcarreau->Piece())->PositionY() != pydep)
                            {
                            echectemp = false;
                            break;
                            }
                         }
                      else {
                           if (tempcarreau->PositionX() == pxarr && tempcarreau->PositionY() == pyarr)
                              {
                              echectemp = false;
                              break;
                              }
                           }
                      if (xfou < 0)
                         {
                         xfou++;
                         }
                      else {
                           xfou--;
                           }
                      if (yfou < 0)
                         {
                         yfou++;
                         }
                      else {
                           yfou--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             if (tempreine->PositionX() == x || tempreine->PositionY() == y)
                {
                bool echectemp = true;
                int tempdep;
                if (tempreine->PositionX() == x)           // Même ligne
                   {
                   tempdep = y - tempreine->PositionY();   // Calcule de l'écart entre la pièce et la case
                   }
                else {                                     // Même colonne
                     tempdep = x - tempreine->PositionX(); // Calcule de l'écart entre la pièce et la case
                     }
                int i;
                if (tempdep < 0)
                   {
                   i = 1;
                   }
                else {
                     i = -1;
                     }
                while (-tempdep != i)
                      {
                      if (tempreine->PositionX() == x)
                         {
                         tempcarreau = (carreau *)(Pcarreau + x - 1 + ((y + i - 1) * 8));
                         }
                      else {
                           tempcarreau = (carreau *)(Pcarreau + x + i - 1 + ((y - 1) * 8));
                           }
                      if (tempcarreau->Piece() != NULL && tempcarreau->Piece() != temproi)
                         {
                         if (((piece *)tempcarreau->Piece())->PositionX() != pxdep || ((piece *)tempcarreau->Piece())->PositionY() != pydep)
                            {
                            echectemp = false;
                            break;
                            }
                         }
                      else {
                           if (tempcarreau->PositionX() == pxarr && tempcarreau->PositionY() == pyarr)
                              {
                              echectemp = false;
                              break;
                              }
                           }
                      if (tempdep < 0)
                         {
                         i++;
                         }
                      else {
                           i--;
                           }
                      }
                if (echectemp == true)
                   {
                   return 1;
                   }
                }
             }
          }
       }
    }
return 0;
}
//---------------------------------------------------------------------------
int __fastcall Echiquier::EstMat(int coul) // 0=rien, 1 = MAT blanc, 2 = MAT noir, 3 = blanc PAT, 4 = noir PAT
{
if (EstEchec(coul)) // échec
   {
   if (DeplacementPossible(coul)) // Pas MAT
      {
      return 0;
      }
   else {
        if (coul == noir) // MAT Noir
           {
           return 2;
           }
        else { // MAT Blanc
             return 1;
             }
        }
   }
else {              // pas échec
     if (DeplacementPossible(coul)) // Pas PAT
        {
        return 0;
        }
     else {
          if (coul == noir) // PAT Noir
             {
             return 4;
             }
          else { // PAT Blanc
               return 3;
               }
          }
     }
}
//---------------------------------------------------------------------------
__fastcall carreau::~carreau()
{
delete image;
}
//---------------------------------------------------------------------------
__fastcall carreau::carreau(void *Parent = NULL)
{
PEchiquier = Parent;
if (PEchiquier != NULL && Ppiece == NULL)
   {
   Ppiece = ((Echiquier *)PEchiquier)->Ppiecevide;
   }
else {
     Ppiece = NULL;
	 }
image = new TImage(NULL);
image->OnDragDrop = CarreauDragDrop;
image->OnDragOver = CarreauDragOver;
image->OnEndDock = CarreauEndDock;
image->OnEndDrag = CarreauEndDrag;
image->OnClick = CarreauClick;
image->OnStartDock = CarreauStartDock;
image->OnStartDrag = CarreauStartDrag;
image->DragKind = dkDrag;
image->DragMode = dmManual;
image->AutoSize = true;
SetPanel((TWinControl *)Parent);
ligne = 0;
colonne = 0;
}
//---------------------------------------------------------------------------
void __fastcall carreau::SetPanel(TWinControl *Panel)
{
image->Parent = Panel;
image->SendToBack();
}
//---------------------------------------------------------------------------
void __fastcall carreau::Parent(void *Parent)
{
PEchiquier = Parent;
}
//---------------------------------------------------------------------------
void* __fastcall carreau::Parent()
{
return PEchiquier;
}
//---------------------------------------------------------------------------
int __fastcall carreau::PositionX()
{
return colonne;
}
//---------------------------------------------------------------------------
void __fastcall carreau::PositionX(int x)
{
if (x < 1)
   {
   x = 1;
   }
if (x > 8)
   {
   x = 8;
   }
colonne = x;
image->Left = taillecase * (colonne - 1);
}
//---------------------------------------------------------------------------
int __fastcall carreau::PositionY()
{
return ligne;
}
//---------------------------------------------------------------------------
void __fastcall carreau::PositionY(int y)
{
if (y < 1)
   {
   y = 1;
   }
if (y > 8)
   {
   y = 8;
   }
ligne = y;
image->Top = taillecase * (8 - ligne);
}
//---------------------------------------------------------------------------
void __fastcall carreau::Couleur(int coul)
{
couleur = coul;
if (couleur == noir)
   {
   image->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauNoir.png");
   }
else {
     image->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauBlanc.png");
     }
}
//---------------------------------------------------------------------------
int __fastcall carreau::Couleur()
{
return couleur;
}
//---------------------------------------------------------------------------
TImage* __fastcall carreau::Image()
{
return image;
}
//---------------------------------------------------------------------------
__fastcall piece::~piece()
{
delete image;
}
//---------------------------------------------------------------------------
__fastcall piece::piece(void *Parent = NULL, int px = 0, int py = 0, int coul = 1, TWinControl *Panel = NULL)
{
actif = 1;
vide = 0;
PEchiquier = Parent;
posx = px;
posy = py;
deplacement = 0;
type = 0;
image = new TImage(NULL);
image->Transparent = true;
image->OnDragDrop = PieceDragDrop;
image->OnDragOver = PieceDragOver;
image->OnEndDock = PieceEndDock;
image->OnEndDrag = PieceEndDrag;
image->OnClick = PieceClick;
image->OnStartDock = PieceStartDock;
image->OnStartDrag = PieceStartDrag;
image->DragKind = dkDrag;
image->DragMode = dmManual;
image->AutoSize = true;
image->Left = taillecase * posx;
image->Top = taillecase * (8 - posy);
SetPanel(Panel);
Couleur(coul);
}
//---------------------------------------------------------------------------
void __fastcall piece::SetPanel(TWinControl *Panel)
{
image->Parent = Panel;
}
//---------------------------------------------------------------------------
void __fastcall piece::Picture(AnsiString pic)
{
try {
    image->Picture->LoadFromFile(pic);
    }
catch (...) {}
if (pic.Pos("Vide") == 0 && pic.Pos("Rien") == 0)
   {
   image->DragMode = dmAutomatic;
   }
else {
     image->DragMode = dmManual;
     }
}
//---------------------------------------------------------------------------
void __fastcall piece::Parent(void *PParent)
{
PEchiquier = PParent;
}
//---------------------------------------------------------------------------
void* __fastcall piece::Parent()
{
return (void *)PEchiquier;
}
//---------------------------------------------------------------------------
int __fastcall piece::PositionX()
{
return posx;
}
//---------------------------------------------------------------------------
int __fastcall piece::PositionY()
{
return posy;
}
//---------------------------------------------------------------------------
void __fastcall piece::PositionX(int x)
{
if (x < 1)
   {
   x = 1;
   }
if (x > 8)
   {
   x = 8;
   }
posx = x;
image->Left = taillecase * (posx - 1);
}
//---------------------------------------------------------------------------
void __fastcall piece::PositionY(int y)
{
if (y < 1)
   {
   y = 1;
   }
if (y > 8)
   {
   y = 8;
   }
posy = y;
image->Top = taillecase * (8 - posy);
}
//---------------------------------------------------------------------------
int __fastcall piece::Actif()
{
return actif;
}
//---------------------------------------------------------------------------
void __fastcall piece::Actif(int act)
{
actif = act;
if (actif == 0)
   {
   SetPanel(NULL);
   (((Echiquier *)PEchiquier)->Pcarreau + ((posx - 1) + ((posy - 1) * 8)))->Piece(NULL);
   posx = 0;
   posy = 0;
   }
else {
     SetPanel((TWinControl *)((Echiquier *)PEchiquier)->Parent());
     (((Echiquier *)PEchiquier)->Pcarreau + ((posx - 1) + ((posy - 1) * 8)))->Piece(this);
     }
}
//---------------------------------------------------------------------------
int __fastcall piece::Vide()
{
return vide;
}
//---------------------------------------------------------------------------
void __fastcall piece::Vide(int vid)
{
vide = vid;
if (vide == true)
   {
   image->DragMode = dmManual;
   }
}
//---------------------------------------------------------------------------
int __fastcall piece::Couleur()
{
return couleur;
}
//---------------------------------------------------------------------------
void __fastcall piece::Couleur(int coul)
{
couleur = coul;
AnsiString tempimg;
if (couleur == noir)
   {
   tempimg = "Noir.png";
   }
else {
     tempimg = "Blanc.png";
     }
image->DragMode = dmAutomatic;
switch (type)             //0=rien, 1=pion, 2=cavalier, 3=tour, 4=fou, 5=reine, 6=roi
       {
       case 0 : tempimg = "PieceRien" + tempimg; image->DragMode = dmManual; break;
       case 1 : tempimg = "PiecePion" + tempimg; break;
       case 2 : tempimg = "PieceCavalier" + tempimg; break;
       case 3 : tempimg = "PieceTour" + tempimg; break;
       case 4 : tempimg = "PieceFou" + tempimg; break;
       case 5 : tempimg = "PieceReine" + tempimg; break;
       case 6 : tempimg = "PieceRoi" + tempimg; break;
       default: tempimg = "PieceRien" + tempimg; image->DragMode = dmManual; break;
       }
image->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + tempimg);
}
//---------------------------------------------------------------------------
void __fastcall piece::Init(int x, int y, int coul)
{
PositionX(x);
PositionY(y);
Couleur(coul);
}
//---------------------------------------------------------------------------
int __fastcall piece::Deplacement()
{
return deplacement;
}
//---------------------------------------------------------------------------
void __fastcall piece::Deplacement(int dep)
{
deplacement = dep;
}
//---------------------------------------------------------------------------
int __fastcall piece::Type()
{
return type;
}
//---------------------------------------------------------------------------
void __fastcall piece::Type(int typ)
{
type = typ;
}
//---------------------------------------------------------------------------
void* __fastcall carreau::Piece()
{
return (void *)Ppiece;
}
//---------------------------------------------------------------------------
void __fastcall carreau::Piece(void *PieceLa)
{
if (PieceLa != NULL)
   {
   if (((piece *)PieceLa)->Vide() == true)
      {
      Ppiece = NULL;
      return;
      }
   }
(void *)Ppiece = (void *)PieceLa;
}
//---------------------------------------------------------------------------
__fastcall pion::~pion()
{
//
}
//---------------------------------------------------------------------------
__fastcall pion::pion(void *Parent = NULL, int px = 1, int py = 2, int coul = 0, TWinControl *Panel = NULL):piece(Parent, px, py, coul, Panel)
{
type = 1;
}
//---------------------------------------------------------------------------
int __fastcall pion::deplacement(int x, int y)
{
Echiquier *Partemp = (Echiquier *)this->Parent(); //on récupère le parent pour une lecture plus facile du code venant à la suite
int ori; //déduction de l'orientation du déplacement en fonction du sens et de la couleur
if (couleur == blanc) // on s'en sert comme multiplicateur pour ajouter ou soustraire.
   {
   if (Partemp->sens == 0)
      {
      ori = 1;
      }
   else {
        ori = -1;
        }
   }
else {
     if (Partemp->sens == 0)
        {
        ori = -1;
        }
     else {
          ori = 1;
          }
     }
if (y > 2 || y < -2 || y == 0 || (y + posy) < 1 ||(y + posy) > 8 || (x + posx) < 1 || (x + posx) > 8  || x < -1 || x > 1 || (y == 2 && (x != 0 || Deplacement() == 1)) || (y != ori && y != (2 * ori)))
   {
   return 0; // si le déplacement est impossible, on arrete
   }
piece *temppiece = (piece *)(Partemp->Pcarreau + ((posx + x - 1) + ((posy + y - 1) * 8)))->Piece();
if (y == 2) //tester si déplacement possible
   {
   if ((Partemp->Pcarreau + (posx - 1 + ((posy - 1 + 1) * 8)))->Piece() != NULL || temppiece != NULL)
      {
      return 0;
      }
   }
if (y == 1 && x == 0) //tester si déplacement possible
   {
   if (temppiece != NULL)
      {
      return 0;
      }
   }
piece *temppriseenpassant = (piece *)Partemp->dernierpion;
if (x != 0) //tester si déplacement possible
   {
   if (temppiece == NULL) // test de la prise en passant
      {
      if (Partemp->dernierpion == NULL)
         {
         return 0;
         }
      if (Partemp->dernierpion != NULL)
         {
         if (temppriseenpassant->PositionX() != (posx + x ) || temppriseenpassant->PositionY() != posy || temppriseenpassant->Couleur() == Couleur())
            {
            return 0;
            }
         else {
              temppiece = temppriseenpassant;
              }
         }
      }
   else {
        if (temppiece->Couleur() == Couleur()) //tester si on mange une pièce pour la désactiver
           {
           return 0;
           }
        }
   }
if (Partemp->EstEchec(posx, posy, posx + x, posy + y, Couleur())) // on vérifie si le mouvement provoquera un échec
   {
   return 0;
   }
if (temppiece != NULL)
   {
   temppiece->Actif(0);
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(NULL);
PositionX(PositionX() + x);
PositionY(PositionY() + y);
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(this);
if (y == 2 || y == -2)
   {
   Partemp->dernierpion = this;
   }
else {
     Partemp->dernierpion = NULL;
     }
this->Deplacement(1);
image->Left = taillecase * (posx - 1);
image->Top = taillecase * (8 - posy);
Partemp->coups++;
if (posy == 1 || posy == 8)
   {
   Changement(-1);
   }
return 1;
}
//---------------------------------------------------------------------------
__fastcall cavalier::~cavalier()
{
//
}
//---------------------------------------------------------------------------
__fastcall cavalier::cavalier(void *Parent = NULL, int px = 2, int py = 1, int coul = 0, TWinControl *Panel = NULL):piece(Parent, px, py, coul, Panel)
{
type = 2;
}
//---------------------------------------------------------------------------
int __fastcall cavalier::deplacement(int x, int y)
{
if (!(((y == 2 || y == -2) && (x == 1 || x == -1)) || ((y == 1 || y == -1) && (x == 2 || x == -2))))
   {
   return 0; // si le déplacement est impossible, on arrete
   }
if ((posx + x) < 1 || (posx + x) > 8 || (posy + y) < 1 ||(posy + y) > 8)
   {
   return 0;
   }
Echiquier *Partemp = (Echiquier *)this->Parent(); //on récupère le parent pour une lecture plus facile du code venant à la suite
piece *temppiece = (piece *)((Partemp->Pcarreau + (posx - 1 + x + ((posy - 1 + y) * 8)))->Piece());
if (temppiece != NULL)
   {
   if (temppiece->Couleur() == couleur) //tester si déplacement possible
      {
      return 0;
      }
   }
if (Partemp->EstEchec( posx, posy, posx + x, posy + y, Couleur())) // on vérifie si le mouvement provoquera un échec
   {
   return 0;
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(NULL);
PositionX(PositionX() + x);
PositionY(PositionY() + y);
if (temppiece != NULL)       //tester si on mange une pièce pour la désactiver
   {
   temppiece->Actif(0);
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(this);
this->Deplacement(1);
Partemp->dernierpion = NULL; // la dernière pièce n'est pas active pour la prise en passant
image->Left = taillecase * (posx - 1);
image->Top = taillecase * (8 - posy);
Partemp->coups++;
return 1;
}
//---------------------------------------------------------------------------
void __fastcall cavalier::copiecavalier(cavalier *P) // constructeur par recopie
{
couleur = P->couleur;
posx = P->posx;
posy = P->posy;
actif = P->actif;
vide = P->vide;
this->Deplacement(P->Deplacement());
type = P->type;
PEchiquier = P->PEchiquier;
if (actif == 1)
   {
   SetPanel((TWinControl *)((Echiquier *)PEchiquier)->Parent());
   Couleur(couleur);
   Init(posx, posy, couleur);
   }
}
//---------------------------------------------------------------------------
__fastcall tour::~tour()
{
//
}
//---------------------------------------------------------------------------
__fastcall tour::tour(void *Parent = NULL, int px = 1, int py = 1, int coul = 0, TWinControl *Panel = NULL):piece(Parent, px, py, coul, Panel)
{
roc = 0;
type = 3;
}
//---------------------------------------------------------------------------
int __fastcall tour::deplacement(int x, int y)
{
if ((y != 0 && x != 0) || (posy + y) < 1 || (posy + y) > 8 || (posx + x) < 1 || (posx + x) > 8)
   {
   return 0; // si le déplacement est impossible, on arrete
   }
Echiquier *Partemp = (Echiquier *)this->Parent(); //on récupère le parent pour une lecture plus facile du code venant à la suite
piece *temppiece = (piece *)((Partemp->Pcarreau + (posx - 1 + x + ((posy - 1 + y) * 8)))->Piece());
if (temppiece != NULL)
   {
   if (temppiece->Couleur() == Couleur()) //tester si déplacement possible
      {
      return 0;
      }
   }
int i;
if ((x + y) > 0)
   {i = 1;}
else {i = -1;}
while (i != (x + y))
      {
      if (y == 0)
         {
         if ((Partemp->Pcarreau + (posx - 1 + i + ((posy - 1) * 8)))->Piece() != NULL)
            {return 0;}
         }
      if (x == 0)
         {
         if ((Partemp->Pcarreau + (posx - 1 + ((posy - 1 + i) * 8)))->Piece() != NULL)
            {return 0;}
         }
      if ((x + y) > 0)
         {i++;}
      else {i--;}
      }
if (Partemp->EstEchec(posx, posy, posx + x, posy + y, Couleur())) // on vérifie si le mouvement provoquera un échec
   {
   return 0;
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(NULL); // on efface son ancienne position
PositionX(posx + x);
PositionY(posy + y);
if (temppiece != NULL)       //tester si on mange une pièce pour la désactiver
   {
   temppiece->Actif(0);
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(this); // mise à jour de sa position sur les carreaux
this->Deplacement(1);
roc = 1; // Le roc n'est plus possible avec cette pièce
Partemp->dernierpion = NULL; // la dernière pièce n'est pas active pour la prise en passant
image->Left = taillecase * (posx - 1);
image->Top = taillecase * (8 - posy);
Partemp->coups++;
return 1;
}
//---------------------------------------------------------------------------
void __fastcall tour::copietour(tour *P)
{
couleur = P->couleur;
posx = P->posx;
posy = P->posy;
actif = P->actif;
vide = P->vide;
this->Deplacement(P->Deplacement());
type = P->type;
PEchiquier = P->PEchiquier;
if (actif == 1)
   {
   SetPanel((TWinControl *)((Echiquier *)PEchiquier)->Parent());
   Couleur(couleur);
   Init(posx, posy, couleur);
   }
}
//---------------------------------------------------------------------------
__fastcall fou::~fou()
{
//
}
//---------------------------------------------------------------------------
__fastcall fou::fou(void *Parent = NULL, int px = 3, int py = 1, int coul = 0, TWinControl *Panel = NULL):piece(Parent, px, py, coul, Panel)
{
type = 4;
}
//---------------------------------------------------------------------------
int __fastcall fou::deplacement(int x, int y)
{
if ((x + y != 0 && x - y) != 0 || (posy + y) < 1 || (posy + y) > 8 || (posx + x) < 1 || (posx + x) > 8)
   {
   return 0; // si le déplacement est impossible, on arrete
   }
Echiquier *Partemp = (Echiquier *)this->Parent(); //on récupère le parent pour une lecture plus facile du code venant à la suite
piece *temppiece = (piece *)((Partemp->Pcarreau + (posx - 1 + x + ((posy - 1 + y) * 8)))->Piece());
if (temppiece != NULL)
   {
   if (temppiece->Couleur() == Couleur()) //tester si déplacement possible
      {
      return 0;
      }
   }
int i;
int j;
if ((x) > 0)
   {i = 1;}
if ((x) < 0)
   {i = -1;}
if ((y) > 0)
   {j = 1;}
if ((y) < 0)
   {j = -1;}
while (i != x || j != y)
      {
      if ((Partemp->Pcarreau + (posx - 1 + i + ((posy - 1 + j) * 8)))->Piece() != NULL)
         {return 0;}
      if ((x) > 0)
         {i++;}
      if ((x) < 0)
         {i--;}
      if ((y) > 0)
         {j++;}
      if ((y) < 0)
         {j--;}
      }
if (Partemp->EstEchec(posx, posy, posx + x, posy + y, Couleur())) // on vérifie si le mouvement provoquera un échec
   {
   return 0;
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(NULL);
PositionX(posx + x);
PositionY(posy + y);
if (temppiece != NULL)       //tester si on mange une pièce pour la désactiver
   {
   temppiece->Actif(0);
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(this);
this->Deplacement(1);
Partemp->dernierpion = NULL;
image->Left = taillecase * (posx - 1);
image->Top = taillecase * (8 - posy);
Partemp->coups++;
return 1;
}
//---------------------------------------------------------------------------
void __fastcall fou::copiefou(fou *P)
{
couleur = P->couleur;
posx = P->posx;
posy = P->posy;
actif = P->actif;
vide = P->vide;
this->Deplacement(P->Deplacement());
type = P->type;
PEchiquier = P->PEchiquier;
if (actif == 1)
   {
   SetPanel((TWinControl *)((Echiquier *)PEchiquier)->Parent());
   Couleur(couleur);
   Init(posx, posy, couleur);
   }
}
//---------------------------------------------------------------------------
__fastcall roi::~roi()
{
//
}
//---------------------------------------------------------------------------
__fastcall roi::roi(void *Parent = NULL, int px = 5, int py = 1, int coul = 0, TWinControl *Panel = NULL):piece(Parent, px, py, coul, Panel)
{
roc = 0;
type = 6;
}
//---------------------------------------------------------------------------
int __fastcall roi::deplacement(int x, int y)
{
if (y == 0 && (x == 2 || x == -2) && roc == 0)
   {
   return Roc(x);
   }
if (y < -1 || y > 1 || x < -1 || x > 1 || (posy + y) < 1 || (posy + y) > 8 || (posx + x) < 1 || (posx + x) > 8)
   {
   return 0; // si le déplacement est impossible, on arrete
   }
Echiquier *Partemp = (Echiquier *)this->Parent(); //on récupère le parent pour une lecture plus facile du code venant à la suite
piece *temppiece = (piece *)((Partemp->Pcarreau + (posx - 1 + x + ((posy - 1 + y) * 8)))->Piece());
if (temppiece != NULL)
   {
   if (temppiece->Couleur() == Couleur()) //tester si déplacement possible
      {
      return 0;
      }
   }
if (Partemp->EstEchec(posx + x, posy + y, Couleur())) // on vérifie si le mouvement provoquera un échec
   {
   return 0;
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(NULL);
PositionX(posx + x);
PositionY(posy + y);
if (temppiece != NULL)       //tester si on mange une pièce pour la désactiver
   {
   temppiece->Actif(0);
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(this);
this->Deplacement(1);
Partemp->dernierpion = NULL;
roc = 1;
image->Left = taillecase * (posx - 1);
image->Top = taillecase * (8 - posy);
Partemp->coups++;
return 1;
}
//---------------------------------------------------------------------------
int __fastcall roi::Roc(int cote) // positif ou négatif par rapport au roi
{
Echiquier *Partemp = (Echiquier *)this->Parent(); //on récupère le parent pour une lecture plus facile du code venant à la suite
tour *temptour;
int pos1;
int pos2;
int pos3 = 0;
if (cote > 0)
   {
   temptour = (tour *)(Partemp->Pcarreau + (8 - 1 + ((posy - 1) * 8)))->Piece();
   pos1 = posx + 1;
   pos2 = posx + 2;
   pos3 = posx + 3;
   }
else {
     temptour = (tour *)(Partemp->Pcarreau + (1 - 1 + ((posy - 1) * 8)))->Piece();
     pos1 = posx - 1;
     pos2 = posx - 2;
     }
if (temptour == NULL)
   {
   return 0;
   }
if (roc == 1 || temptour->roc == 1)
   {
   return 0;
   }
if (Partemp->EstEchec(Couleur()))
   {
   return 0;
   }
if (Partemp->EstEchec(Couleur()) == 0) // test si roc possible
   {
   if (temptour->roc == 0)
      {
      if (Partemp->EstEchec(pos1, posy, Couleur()) == 0 && (Partemp->Pcarreau + (pos1 - 1 + ((posy - 1) * 8)))->Piece() == NULL)
         {
         if (Partemp->EstEchec(pos2, posy, Couleur()) == 0 && (Partemp->Pcarreau + (pos2 - 1 + ((posy - 1) * 8)))->Piece() == NULL)
            {
            if (pos3 != 0)
               {
               if (Partemp->EstEchec(pos3, posy, Couleur()) == 0 && (Partemp->Pcarreau + (pos3 - 1 + ((posy - 1) * 8)))->Piece() == NULL)
                  {
                  if (ScanRoc(temptour) == 0)
                     {
                     return 0;
                     }
                  }
               else {
                    if (ScanRoc(temptour) == 0)
                       {
                       return 0;
                       }
                    }
               }
            else {
                 if (ScanRoc(temptour) == 0)
                    {
                    return 0;
                    }
                 }
            }
         else {
              return 0;
              }
         }
      else {
           return 0;
           }
      }
   else {
        return 0;
        }
   }
else {
     return 0;
     }
if (temptour->PositionX() - posx > 0)
   {
   if (Partemp->sens == 0)
      {
      temptour->deplacement(-2, 0);
      }
   else {
        temptour->deplacement(-3, 0);
        }
   }
else {
     if (Partemp->sens == 0)
        {
        temptour->deplacement(3, 0);
        }
     else {
          temptour->deplacement(2, 0);
          }
     }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(NULL);
PositionX(pos2);
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(this);
roc = 1;
temptour->roc = 1;
this->Deplacement(1);
Partemp->dernierpion = NULL;
image->Left = taillecase * (posx - 1);
image->Top = taillecase * (8 - posy);
//Partemp->coups++;
return 1;
}
//---------------------------------------------------------------------------
__fastcall reine::~reine()
{
//
}
//---------------------------------------------------------------------------
__fastcall reine::reine(void *Parent = NULL, int px = 4, int py = 1, int coul = 0, TWinControl *Panel = NULL):piece(Parent, px, py, coul, Panel)
{
type = 5;
}
//---------------------------------------------------------------------------
int __fastcall reine::deplacement(int x, int y)
{
if (((x + y != 0 && x - y != 0) && (y != 0 && x != 0)) || (posy + y) < 1 || (posy + y) > 8 || (posx + x) < 1 || (posx + x) > 8)
   {
   return 0; // si le déplacement est impossible, on arrete
   }
Echiquier *Partemp = (Echiquier *)this->Parent(); //on récupère le parent pour une lecture plus facile du code venant à la suite
piece *temppiece = (piece *)((Partemp->Pcarreau + (posx - 1 + x + ((posy - 1 + y) * 8)))->Piece());
int i = 0;
int j = 0;
if (y == 0 || x == 0)
   {
   if ((x + y) > 0)
      {i = 1;}
   else {i = -1;}
   while (i != (x + y))
         {
         if (y == 0)
            {
            if ((Partemp->Pcarreau + (posx - 1 + i + ((posy - 1) * 8)))->Piece() != NULL)
               {return 0;}
            }
         if (x == 0)
            {
            if ((Partemp->Pcarreau + (posx - 1 + ((posy - 1 + i) * 8)))->Piece() != NULL)
               {return 0;}
            }
         if ((x + y) > 0)
            {i++;}
         else {i--;}
         }
   }
else {
     if ((x) > 0)
        {i = 1;}
     if ((x) < 0)
        {i = -1;}
     if ((y) > 0)
        {j = 1;}
     if ((y) < 0)
        {j = -1;}
     while (i != x || j != y)
         {
         if ((Partemp->Pcarreau + (posx - 1 + i + ((posy - 1 + j) * 8)))->Piece() != NULL)
            {return 0;}
         if ((x) > 0)
            {i++;}
         if ((x) < 0)
            {i--;}
         if ((y) > 0)
            {j++;}
         if ((y) < 0)
            {j--;}
         }
    }
if (temppiece != NULL)
   {
   if (temppiece->Couleur() == Couleur()) //tester si déplacement possible
      {
      return 0;
      }
   }
if (Partemp->EstEchec(posx, posy, posx + x, posy + y, Couleur())) // on vérifie si le mouvement provoquera un échec
   {
   return 0;
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(NULL);
PositionX(posx + x);
PositionY(posy + y);
if (temppiece != NULL)       //tester si on mange une pièce pour la désactiver
   {
   temppiece->Actif(0);
   }
(Partemp->Pcarreau + (posx - 1 + ((posy - 1) * 8)))->Piece(this);
this->Deplacement(1);
Partemp->dernierpion = NULL;
image->Left = taillecase * (posx - 1);
image->Top = taillecase * (8 - posy);
Partemp->coups++;
return 1;
}
//---------------------------------------------------------------------------
void __fastcall reine::copiereine(reine *P)
{
couleur = P->couleur;
posx = P->posx;
posy = P->posy;
actif = P->actif;
vide = P->vide;
this->Deplacement(P->Deplacement());
type = P->type;
PEchiquier = P->PEchiquier;
if (actif == 1)
   {
   SetPanel((TWinControl *)((Echiquier *)PEchiquier)->Parent());
   Couleur(couleur);
   Init(posx, posy, couleur);
   }
}
//---------------------------------------------------------------------------
__fastcall Echiquier::Echiquier(void *owner, bool Fsens)
{
ReineBlanc = L"\u2655";
RoiBlanc = L"\u2654";
TourBlanc = L"\u2656";
CavalierBlanc = L"\u2658";
FouBlanc = L"\u2657";
PionBlanc = L"\u2659";
ReineNoir = L"\u265B";
RoiNoir = L"\u265A";
TourNoir = L"\u265C";
CavalierNoir = L"\u265E";
FouNoir = L"\u265D";
PionNoir = L"\u265F";
sens = Fsens; // permet de déterminer le sens de l'échiquier (0 = blanc en bas)
int startbx = 1;
int startnx = 8;
int placereine = 4;
int placeroi = 5;
if (sens == 1)
   {
   startbx = 8;
   startnx = 1;
   placereine = 5;
   placeroi = 4;
   }
drag = NULL;
Parent(owner);
coups = 0;
Ppiecevide = new piece();
Ppiecevide->Vide(true);
Ppiecevide->Type(0);
Ppiecevide->Parent(this);
Ppiecevide->Picture(ExtractFilePath(Application->ExeName) + "PieceVide.png");
Prevision = new TList;
Pcarreau = new carreau[64];
Ppion = new pion[16];
Pcavalier = new cavalier[4];
Nbcavalier = 4;
Nbtour = 4;
Nbfou = 4;
Nbreine = 2;
Ptour = new tour[4];
Pfou = new fou[4];
Proi = new roi[2];
Preine = new reine[2];
Preine->Picture(ExtractFilePath(Application->ExeName) + "PieceReineBlanc.png");
Preine->SetPanel((TWinControl *)owner);
Preine->Init(placereine, startbx, blanc);
(Preine+1)->Picture(ExtractFilePath(Application->ExeName) + "PieceReineNoir.png");
(Preine+1)->SetPanel((TWinControl *)owner);
(Preine+1)->Init(placereine, startnx, noir);
Proi->Picture(ExtractFilePath(Application->ExeName) + "PieceRoiBlanc.png");
Proi->SetPanel((TWinControl *)owner);
Proi->Init(placeroi, startbx, blanc);
(Proi+1)->Picture(ExtractFilePath(Application->ExeName) + "PieceRoiNoir.png");
(Proi+1)->SetPanel((TWinControl *)owner);
(Proi+1)->Init(placeroi, startnx, noir);
Pfou->Picture(ExtractFilePath(Application->ExeName) + "PieceFouBlanc.png");
Pfou->SetPanel((TWinControl *)owner);
Pfou->Init(3, startbx, blanc);
(Pfou+1)->Picture(ExtractFilePath(Application->ExeName) + "PieceFouNoir.png");
(Pfou+1)->SetPanel((TWinControl *)owner);
(Pfou+1)->Init(3, startnx, noir);
(Pfou+2)->Picture(ExtractFilePath(Application->ExeName) + "PieceFouBlanc.png");
(Pfou+2)->SetPanel((TWinControl *)owner);
(Pfou+2)->Init(6, startbx, blanc);
(Pfou+3)->Picture(ExtractFilePath(Application->ExeName) + "PieceFouNoir.png");
(Pfou+3)->SetPanel((TWinControl *)owner);
(Pfou+3)->Init(6, startnx, noir);
Pcavalier->Picture(ExtractFilePath(Application->ExeName) + "PieceCavalierBlanc.png");
Pcavalier->SetPanel((TWinControl *)owner);
Pcavalier->Init(2, startbx, blanc);
(Pcavalier+1)->Picture(ExtractFilePath(Application->ExeName) + "PieceCavalierNoir.png");
(Pcavalier+1)->SetPanel((TWinControl *)owner);
(Pcavalier+1)->Init(2, startnx, noir);
(Pcavalier+2)->Picture(ExtractFilePath(Application->ExeName) + "PieceCavalierBlanc.png");
(Pcavalier+2)->SetPanel((TWinControl *)owner);
(Pcavalier+2)->Init(7, startbx, blanc);
(Pcavalier+3)->Picture(ExtractFilePath(Application->ExeName) + "PieceCavalierNoir.png");
(Pcavalier+3)->SetPanel((TWinControl *)owner);
(Pcavalier+3)->Init(7, startnx, noir);
Ptour->Picture(ExtractFilePath(Application->ExeName) + "PieceTourBlanc.png");
Ptour->SetPanel((TWinControl *)owner);
Ptour->Init(1, startbx, blanc);
(Ptour+1)->Picture(ExtractFilePath(Application->ExeName) + "PieceTourNoir.png");
(Ptour+1)->SetPanel((TWinControl *)owner);
(Ptour+1)->Init(1, startnx, noir);
(Ptour+2)->Picture(ExtractFilePath(Application->ExeName) + "PieceTourBlanc.png");
(Ptour+2)->SetPanel((TWinControl *)owner);
(Ptour+2)->Init(8, startbx, blanc);
(Ptour+3)->Picture(ExtractFilePath(Application->ExeName) + "PieceTourNoir.png");
(Ptour+3)->SetPanel((TWinControl *)owner);
(Ptour+3)->Init(8, startnx, noir);
Preine->Parent(this);
(Preine+1)->Parent(this);
Proi->Parent(this);
(Proi+1)->Parent(this);
Pfou->Parent(this);
(Pfou+1)->Parent(this);
(Pfou+2)->Parent(this);
(Pfou+3)->Parent(this);
Pcavalier->Parent(this);
(Pcavalier+1)->Parent(this);
(Pcavalier+2)->Parent(this);
(Pcavalier+3)->Parent(this);
Ptour->Parent(this);
(Ptour+1)->Parent(this);
(Ptour+2)->Parent(this);
(Ptour+3)->Parent(this);
dernierpion = NULL;
int tempcoul = noir;
for (int i = 0; i < 8; i++) // initialisation des cases de l'échiquer
    {
    for (int j = 0; j < 8; j++)
        {
        carreau *temp = (Pcarreau+(j+i*8));
        temp->Parent(this);
        temp->SetPanel((TWinControl *)owner);
        temp->Couleur(tempcoul);
        temp->PositionX(j + 1);
        temp->PositionY(i + 1);
        temp->Piece(NULL);
        if (tempcoul == blanc)
           {
           tempcoul = noir;
           }
        else {
             tempcoul = blanc;
             }
        }
    if (tempcoul == blanc)
       {
       tempcoul = noir;
       }
    else {
         tempcoul = blanc;
         }
    }
Preine->Init(placereine, startbx, blanc); // pour corriger un bug d'une librairie
startbx = 2;
startnx = 7;
if (sens == 1)
   {
   startbx = 7;
   startnx = 2;
   }
for (int i = 0; i < 8; i++) // Positionnement des pions.
    {
    (Ppion+i)->Init(i + 1, startbx, blanc);
    (Ppion+(i+8))->Init(i + 1, startnx, noir);
    (Ppion+i)->Parent(this);
    (Ppion+i)->SetPanel((TWinControl *)owner);
    (Ppion+(i+8))->Parent(this);
    (Ppion+(i+8))->SetPanel((TWinControl *)owner);
    (Pcarreau + ((Ppion+i)->PositionX() - 1 + (((Ppion+i)->PositionY() - 1) * 8)))->Piece(Ppion+i); // remplissage des carreaux
    (Pcarreau + ((Ppion+i+8)->PositionX() - 1 + (((Ppion+i+8)->PositionY() - 1) * 8)))->Piece(Ppion+i+8);
    }
(Pcarreau + (Ptour->PositionX() - 1 + ((Ptour->PositionY() - 1) * 8)))->Piece(Ptour); // initialisation des positions des pièces sur les carreaux
(Pcarreau + ((Ptour+1)->PositionX() - 1 + (((Ptour+1)->PositionY() - 1) * 8)))->Piece(Ptour+1);
(Pcarreau + ((Ptour+2)->PositionX() - 1 + (((Ptour+2)->PositionY() - 1) * 8)))->Piece(Ptour+2);
(Pcarreau + ((Ptour+3)->PositionX() - 1 + (((Ptour+3)->PositionY() - 1) * 8)))->Piece(Ptour+3);
(Pcarreau + (Pcavalier->PositionX() - 1 + ((Pcavalier->PositionY() - 1) * 8)))->Piece(Pcavalier);
(Pcarreau + ((Pcavalier+1)->PositionX() - 1 + (((Pcavalier+1)->PositionY() - 1) * 8)))->Piece(Pcavalier+1);
(Pcarreau + ((Pcavalier+2)->PositionX() - 1 + (((Pcavalier+2)->PositionY() - 1) * 8)))->Piece(Pcavalier+2);
(Pcarreau + ((Pcavalier+3)->PositionX() - 1 + (((Pcavalier+3)->PositionY() - 1) * 8)))->Piece(Pcavalier+3);
(Pcarreau + (Pfou->PositionX() - 1 + ((Pfou->PositionY() - 1) * 8)))->Piece(Pfou);
(Pcarreau + ((Pfou+1)->PositionX() - 1 + (((Pfou+1)->PositionY() - 1) * 8)))->Piece(Pfou+1);
(Pcarreau + ((Pfou+2)->PositionX() - 1 + (((Pfou+2)->PositionY() - 1) * 8)))->Piece(Pfou+2);
(Pcarreau + ((Pfou+3)->PositionX() - 1 + (((Pfou+3)->PositionY() - 1) * 8)))->Piece(Pfou+3);
(Pcarreau + (Preine->PositionX() - 1 + ((Preine->PositionY() - 1) * 8)))->Piece(Preine);
(Pcarreau + ((Preine+1)->PositionX() - 1 + (((Preine+1)->PositionY() - 1) * 8)))->Piece(Preine+1);
(Pcarreau + (Proi->PositionX() - 1 + ((Proi->PositionY() - 1) * 8)))->Piece(Proi);
(Pcarreau + ((Proi+1)->PositionX() - 1 + (((Proi+1)->PositionY() - 1) * 8)))->Piece(Proi+1);
((TWinControl *)owner)->Width = (Pcarreau + 7)->Image()->Left + (Pcarreau + 7)->Image()->Width;
((TWinControl *)owner)->Height = (Pcarreau + 7)->Image()->Top + (Pcarreau + 7)->Image()->Height;
}
//---------------------------------------------------------------------------
__fastcall Echiquier::~Echiquier()
{
delete Prevision;
delete[] Pcarreau;
delete[] Ppion;
delete[] Pcavalier;
delete[] Ptour;
delete[] Pfou;
delete[] Proi;
delete[] Preine;
delete Ppiecevide;
}
//---------------------------------------------------------------------------
void* __fastcall Echiquier::Parent()
{
return Pparent;
}
//---------------------------------------------------------------------------
void __fastcall Echiquier::Parent(void *Parent)
{
Pparent = Parent;
}
//---------------------------------------------------------------------------
void __fastcall pion::Changement(int IPiece) //-1=demande 0=cavalier, 1=tour, 2=fou, 3>=reine
{
if (IPiece == -1)
   {
   switch (MessageBox(0, "Voulez-vous changer votre pion en reine", "Changement d'un pion?", MB_YESNO + MB_TOPMOST))
          {
          case IDYES: IPiece = 3; break; // reine
          case IDNO:  switch (MessageBox(0, "Voulez-vous changer votre pion en tour?", "Changement d'un pion", MB_YESNO + MB_TOPMOST))
                             {
                             case IDYES: IPiece = 1; break; // tour
                             case IDNO:  switch (MessageBox(0, "Voulez-vous changer votre pion en fou?", "Changement d'un pion", MB_YESNO + MB_TOPMOST))
                                                {
                                                case IDYES: IPiece = 2; break; // fou
                                                case IDNO: IPiece = 0; break; // cavalier
                                                }
                                         break;
                             }
                      break;
          }
   }
if (actif == 0)
   {
   return;
   }
Echiquier *Partemp = (Echiquier *)PEchiquier;
if (IPiece == 0) // Cavalier
   {
   if (couleur == noir)
      {
      Changementstr = CavalierNoir;
      }
   else {
        Changementstr = CavalierBlanc;
        }
   Partemp->Nbcavalier = Partemp->Nbcavalier + 1;
   cavalier *Temp = new cavalier[Partemp->Nbcavalier];
   for (int i = 0; i < (Partemp->Nbcavalier - 1); i++)
       {
       (Temp+i)->copiecavalier(&Partemp->Pcavalier[i]);
       if ((Temp+i)->Actif() == 1)
          {
          (Partemp->Pcarreau + ((Temp+i)->PositionX() - 1 + (((Temp+i)->PositionY() - 1) * 8)))->Piece(Temp+i);
          }
       }
   delete[] Partemp->Pcavalier;
   Partemp->Pcavalier = Temp;
   (Partemp->Pcavalier+Partemp->Nbcavalier-1)->Init(PositionX(), PositionY(), Couleur());
   (Partemp->Pcavalier+Partemp->Nbcavalier-1)->Parent(Partemp);
   (Partemp->Pcavalier+Partemp->Nbcavalier-1)->SetPanel((TWinControl *)Partemp->Parent());
   (Partemp->Pcarreau + ((Partemp->Pcavalier+Partemp->Nbcavalier-1)->PositionX() - 1 + (((Partemp->Pcavalier+Partemp->Nbcavalier-1)->PositionY() - 1) * 8)))->Piece((Partemp->Pcavalier+Partemp->Nbcavalier-1));
   }
if (IPiece == 1) // Tour
   {
   if (couleur == noir)
      {
      Changementstr = TourNoir;
      }
   else {
        Changementstr = TourBlanc;
        }
   Partemp->Nbtour = Partemp->Nbtour + 1;
   tour *Temp = new tour[Partemp->Nbtour];
   for (int i = 0; i < (Partemp->Nbtour - 1); i++)
       {
       (Temp+i)->copietour(&Partemp->Ptour[i]);
       if ((Temp+i)->Actif() == 1)
          {
          (Partemp->Pcarreau + ((Temp+i)->PositionX() - 1 + (((Temp+i)->PositionY() - 1) * 8)))->Piece(Temp+i);
          }
       }
   delete[] Partemp->Ptour;
   Partemp->Ptour = Temp;
   (Partemp->Ptour+Partemp->Nbtour-1)->Init(PositionX(), PositionY(), Couleur());
   (Partemp->Ptour+Partemp->Nbtour-1)->Parent(Partemp);
   (Partemp->Ptour+Partemp->Nbtour-1)->SetPanel((TWinControl *)Partemp->Parent());
   (Partemp->Pcarreau + ((Partemp->Ptour+Partemp->Nbtour-1)->PositionX() - 1 + (((Partemp->Ptour+Partemp->Nbtour-1)->PositionY() - 1) * 8)))->Piece((Partemp->Ptour+Partemp->Nbtour-1));
   }
if (IPiece == 2) // Fou
   {
   if (couleur == noir)
      {
      Changementstr = FouNoir;
      }
   else {
        Changementstr = FouBlanc;
        }
   Partemp->Nbfou = Partemp->Nbfou + 1;
   fou *Temp = new fou[Partemp->Nbfou];
   for (int i = 0; i < (Partemp->Nbfou - 1); i++)
       {
       (Temp+i)->copiefou(&Partemp->Pfou[i]);
       if ((Temp+i)->Actif() == 1)
          {
          (Partemp->Pcarreau + ((Temp+i)->PositionX() - 1 + (((Temp+i)->PositionY() - 1) * 8)))->Piece(Temp+i);
          }
       }
   delete[] Partemp->Pfou;
   Partemp->Pfou = Temp;
   (Partemp->Pfou+Partemp->Nbfou-1)->Init(PositionX(), PositionY(), Couleur());
   (Partemp->Pfou+Partemp->Nbfou-1)->Parent(Partemp);
   (Partemp->Pfou+Partemp->Nbfou-1)->SetPanel((TWinControl *)Partemp->Parent());
   (Partemp->Pcarreau + ((Partemp->Pfou+Partemp->Nbfou-1)->PositionX() - 1 + (((Partemp->Pfou+Partemp->Nbfou-1)->PositionY() - 1) * 8)))->Piece((Partemp->Pfou+Partemp->Nbfou-1));
   }
if (IPiece == 3) // Reine
   {
   if (couleur == noir)
      {
      Changementstr = ReineNoir;
      }
   else {
        Changementstr = ReineBlanc;
        }
   Partemp->Nbreine = Partemp->Nbreine + 1;
   reine *Temp = new reine[Partemp->Nbreine];
   for (int i = 0; i < (Partemp->Nbreine - 1); i++)
       {
       (Temp+i)->copiereine(&Partemp->Preine[i]);
       if ((Temp+i)->Actif() == 1) // test si la pièce n'est plus sur l'échiquier
          {
          (Partemp->Pcarreau + ((Temp+i)->PositionX() - 1 + (((Temp+i)->PositionY() - 1) * 8)))->Piece(Temp+i);
          }
       }
   delete[] Partemp->Preine;
   Partemp->Preine = Temp;
   (Partemp->Preine+Partemp->Nbreine-1)->Init(PositionX(), PositionY(), Couleur());
   (Partemp->Preine+Partemp->Nbreine-1)->Parent(Partemp);
   (Partemp->Preine+Partemp->Nbreine-1)->SetPanel((TWinControl *)Partemp->Parent());
   (Partemp->Pcarreau + ((Partemp->Preine+Partemp->Nbreine-1)->PositionX() - 1 + (((Partemp->Preine+Partemp->Nbreine-1)->PositionY() - 1) * 8)))->Piece((Partemp->Preine+Partemp->Nbreine-1));
   }
actif = 0;
SetPanel(NULL);
posx = 0;
posy = 0;
}
//---------------------------------------------------------------------------
void __fastcall carreau::CarreauDragDrop(TObject *Sender, TObject *Source, int X, int Y)
{ // c'est la fonction qui permet de gérer la fin du drag&drop
  // la source est la pièce déplacé et le sender est le carreau où on la déplace
Echiquier *echiquiertemp = (Echiquier *)PEchiquier;
piece *temp = echiquiertemp->drag; // on sauvegarde la pièce en question pour éviter une recherche plus tard
if (temp == NULL)
   {
   return;
   }
int x = PositionX() - temp->PositionX(); // calcul des déplacements
int y = PositionY() - temp->PositionY();
if (x == 0 && y == 0)
   {
   return;
   }
UnicodeString xtemp;
switch (temp->PositionX())
       {
       case 1 : xtemp = "a"; break;
       case 2 : xtemp = "b"; break;
       case 3 : xtemp = "c"; break;
       case 4 : xtemp = "d"; break;
       case 5 : xtemp = "e"; break;
       case 6 : xtemp = "f"; break;
       case 7 : xtemp = "g"; break;
       case 8 : xtemp = "h"; break;
       }
xtemp = xtemp + IntToStr(temp->PositionY());
switch (PositionX())
       {
       case 1 : xtemp = xtemp + "-a"; break;
       case 2 : xtemp = xtemp + "-b"; break;
       case 3 : xtemp = xtemp + "-c"; break;
       case 4 : xtemp = xtemp + "-d"; break;
       case 5 : xtemp = xtemp + "-e"; break;
       case 6 : xtemp = xtemp + "-f"; break;
       case 7 : xtemp = xtemp + "-g"; break;
       case 8 : xtemp = xtemp + "-h"; break;
       }
xtemp = xtemp + IntToStr(PositionY());
switch (temp->Type()) // type : 1=pion, 2=cavalier, 3=tour, 4=fou, 5=reine, 6=roi
       {
       case 1 : if (((pion *)temp)->deplacement(x, y))
                   {
                   if (PositionY() == 8 || PositionY() <= 1)
                      {
                      xtemp = xtemp + "=" + Changementstr;
                      }
                   if (((pion *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(PionNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(PionBlanc + xtemp);
                        }
                   }
                break;
       case 2 : if (((cavalier *)temp)->deplacement(x, y))
                   {
                   if (((cavalier *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(CavalierNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(CavalierBlanc + xtemp);
                        }
                   }
                break;
       case 3 : if (((tour *)temp)->deplacement(x, y))
                   {
                   if (((tour *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(TourNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(TourBlanc + xtemp);
                        }
                   }
                break;
       case 4 : if (((fou *)temp)->deplacement(x, y))
                   {
                   if (((fou *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(FouNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(FouBlanc + xtemp);
                        }
                   }
                break;
       case 5 : if (((reine *)temp)->deplacement(x, y))
                   {
                   if (((reine *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(ReineNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(ReineBlanc + xtemp);
                        }
                   }
                break;
       case 6 : if (((roi *)temp)->deplacement(x, y))
                   {
                   if (((roi *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(RoiNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(RoiBlanc + xtemp);
                        }
                   }
                break;
       }
int coul;
if (temp->Couleur() == noir)
   {
   coul = blanc;
   }
else {
     coul = noir;
     }
switch (echiquiertemp->EstMat(coul)) // 0=rien, 1 = MAT blanc, 2 = MAT noir, 2 = blanc PAT, 3 = noir PAT
       {
       case 0 : break; //rien
       case 1 : // MAT blanc
                MessageBox(0, "Les blancs sont MAT. Les noirs gagnent la partie.",
                    "Fin de la partie", MB_OK + MB_TOPMOST);
                break;
       case 2 : // MAT noir
                MessageBox(0, "Les noirs sont MAT. Les blancs gagnent la partie.",
                    "Fin de la partie", MB_OK + MB_TOPMOST);
                break;
       case 3 : // blanc PAT
                MessageBox(0, "Les blancs sont PAT. Egalité.",
                    "Fin de la partie", MB_OK + MB_TOPMOST);
                break;
       case 4 : // noir PAT
                MessageBox(0, "Les noirs sont PAT. Egalité.",
                    "Fin de la partie", MB_OK + MB_TOPMOST);
                break;
       }
}
//---------------------------------------------------------------------------
void __fastcall carreau::CarreauDragOver(TObject *Sender, TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
Accept = Source->ClassNameIs("TImage"); // Permet d'accepter ou non le relachement de l'objet
}
//---------------------------------------------------------------------------
void __fastcall carreau::CarreauEndDock(TObject *Sender, TObject *Target, int X, int Y)
{
//
}
//---------------------------------------------------------------------------
void __fastcall carreau::CarreauEndDrag(TObject *Sender, TObject *Target, int X, int Y)
{
//
}
//---------------------------------------------------------------------------
void __fastcall carreau::CarreauClick(TObject *Sender)
{
//
}
//---------------------------------------------------------------------------
void __fastcall carreau::CarreauStartDock(TObject *Sender, TDragDockObject *&DragObject)
{
//
}
//---------------------------------------------------------------------------
void __fastcall carreau::CarreauStartDrag(TObject *Sender, TDragObject *&DragObject)
{
//
}
//---------------------------------------------------------------------------
void __fastcall piece::PieceDragDrop(TObject *Sender, TObject *Source, int X, int Y)
{ // c'est la fonction qui permet de gérer la fin du drag&drop
  // la source est la pièce déplacé et le sender est le carreau où on la déplace
Echiquier *echiquiertemp = (Echiquier *)PEchiquier;
piece *temp = echiquiertemp->drag; // on sauvegarde la pièce en question pour éviter une recherche plus tard
if (temp == NULL)
   {
   return;
   }
int x = PositionX() - temp->PositionX(); // calcul des déplacements
int y = PositionY() - temp->PositionY();
if (x == 0 && y == 0)
   {
   return;
   }
UnicodeString xtemp;
switch (temp->PositionX())
       {
       case 1 : xtemp = "a"; break;
       case 2 : xtemp = "b"; break;
       case 3 : xtemp = "c"; break;
       case 4 : xtemp = "d"; break;
       case 5 : xtemp = "e"; break;
       case 6 : xtemp = "f"; break;
       case 7 : xtemp = "g"; break;
       case 8 : xtemp = "h"; break;
       }
xtemp = xtemp + IntToStr(temp->PositionY());
switch (PositionX())
       {
       case 1 : xtemp = xtemp + "-a"; break;
       case 2 : xtemp = xtemp + "-b"; break;
       case 3 : xtemp = xtemp + "-c"; break;
       case 4 : xtemp = xtemp + "-d"; break;
       case 5 : xtemp = xtemp + "-e"; break;
       case 6 : xtemp = xtemp + "-f"; break;
       case 7 : xtemp = xtemp + "-g"; break;
       case 8 : xtemp = xtemp + "-h"; break;
       }
xtemp = xtemp + IntToStr(PositionY());
switch (temp->Type()) // type : 1=pion, 2=cavalier, 3=tour, 4=fou, 5=reine, 6=roi
       {
       case 1 : if (((pion *)temp)->deplacement(x, y))
                   {
                   if (PositionY() == 8 || PositionY() <= 1)
                      {
                      xtemp = xtemp + "=" + Changementstr;
                      }
                   if (((pion *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(PionNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(PionBlanc + xtemp);
                        }
                   }
                break;
       case 2 : if (((cavalier *)temp)->deplacement(x, y))
                   {
                   if (((cavalier *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(CavalierNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(CavalierBlanc + xtemp);
                        }
                   }
                break;
       case 3 : if (((tour *)temp)->deplacement(x, y))
                   {
                   if (((tour *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(TourNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(TourBlanc + xtemp);
                        }
                   }
                break;
       case 4 : if (((fou *)temp)->deplacement(x, y))
                   {
                   if (((fou *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(FouNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(FouBlanc + xtemp);
                        }
                   }
                break;
       case 5 : if (((reine *)temp)->deplacement(x, y))
                   {
                   if (((reine *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(ReineNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(ReineBlanc + xtemp);
                        }
                   }
                break;
       case 6 : if (((roi *)temp)->deplacement(x, y))
                   {
                   if (((roi *)temp)->Couleur())
                      {
                      Form1->Memo1->Lines->Add(RoiNoir + xtemp);
                      }
                   else {
                        Form1->Memo1->Lines->Add(RoiBlanc + xtemp);
                        }
                   }
                break;
       }
}
//---------------------------------------------------------------------------
void __fastcall piece::PieceDragOver(TObject *Sender, TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
Accept = Source->ClassNameIs("TImage"); // Permet d'accepter ou non le relachement de l'objet
}
//---------------------------------------------------------------------------
void __fastcall piece::PieceEndDock(TObject *Sender, TObject *Target, int X, int Y)
{
//
}
//---------------------------------------------------------------------------
void __fastcall piece::PieceEndDrag(TObject *Sender, TObject *Target, int X, int Y)
{
Echiquier *echiquiertemp = (Echiquier *)PEchiquier;  
while (echiquiertemp->Prevision->Count > 0)
      { // permet d'actualiser la couleur des cases.
      ((carreau *)echiquiertemp->Prevision->Items[0])->Couleur(((carreau *)echiquiertemp->Prevision->Items[0])->Couleur());
      echiquiertemp->Prevision->Delete(0);
      }
echiquiertemp->drag = NULL; // on arrêter le drag&drop
}
//---------------------------------------------------------------------------
void __fastcall piece::PieceClick(TObject *Sender)
{
//
}
//---------------------------------------------------------------------------
void __fastcall piece::PieceStartDock(TObject *Sender, TDragDockObject *&DragObject)
{
//
}
//---------------------------------------------------------------------------
void __fastcall piece::PieceStartDrag(TObject *Sender, TDragObject *&DragObject)
{
int typepiece, px, py;
piece *piecetemp = this;
Echiquier *echiquiertemp = (Echiquier *)PEchiquier;
if (echiquiertemp->coups % 2 && couleur == blanc)
   {
   echiquiertemp->drag = NULL; // on arrêter le drag&drop
   return;
   }
if (!(echiquiertemp->coups % 2) && couleur == noir)
   {
   echiquiertemp->drag = NULL; // on arrêter le drag&drop
   return;
   }
while (echiquiertemp->Prevision->Count > 0)
      { // permet d'actualiser la couleur des cases.
      ((carreau *)echiquiertemp->Prevision->Items[0])->Couleur(((carreau *)echiquiertemp->Prevision->Items[0])->Couleur());
      echiquiertemp->Prevision->Delete(0);
      }
echiquiertemp->drag = this; // on sauvegarde la pièce en question pour éviter une recherche plus tard
// Calculs des prévisions
typepiece = piecetemp->Type();
px = piecetemp->PositionX();
py = piecetemp->PositionY();
TImage *imagetemp; // pour pouvoir modifier son image en vert
piece *temppriseenpassant;
carreau *carreautemp;
piece *temppiece;
bool echec, testactif;
int ori; //déduction de l'orientation du déplacement en fonction du sens et de la couleur
if (couleur == blanc) // on s'en sert comme multiplicateur pour ajouter ou soustraire.
   {
   if (echiquiertemp->sens == 0)
      {
      ori = 1;
      }
   else {
        ori = -1;
        }
   }
else {
     if (echiquiertemp->sens == 0)
        {
        ori = -1;
        }
     else {
          ori = 1;
          }
     }
imagetemp = (echiquiertemp->Pcarreau + ((px - 1) + ((py - 1) * 8)))->Image();
echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 1) + ((py - 1) * 8))); // ajout de la case aux prévisions
imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelectRouge.png"); // change la couleur de la case de la pièce à déplacer
switch (typepiece)
       {
       //1=pion, 2=cavalier, 3=tour, 4=fou, 5=reine, 6=roi
       case 1 : // prévision pour un pion
                if (Deplacement() == 0)
                   {
                   temppiece = (piece *)((echiquiertemp->Pcarreau + ((px - 1) + ((py + (2 * ori) - 1) * 8)))->Piece());
                   echec = echiquiertemp->EstEchec(px, py, px, py + (2 * ori), couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                   if (echec == 0 && ((echiquiertemp->Pcarreau + ((px - 1) + ((py + ori - 1) * 8)))->Piece() == NULL) && temppiece == NULL)
                      { // avance de 2 cases du pion
                      imagetemp = (echiquiertemp->Pcarreau + ((px - 1) + ((py + (2 * ori) - 1) * 8)))->Image(); // Prise en compte de la 2ème case
                      echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 1) + ((py + (2 * ori) - 1) * 8))); // ajout de la case aux prévisions
                      imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                      }
                   }
				echec = echiquiertemp->EstEchec(px, py, px, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                if (echec == 0 && ((echiquiertemp->Pcarreau + ((px - 1) + ((py + ori - 1) * 8)))->Piece() == NULL))
                   { // avance d'une case du pion
                   imagetemp = (echiquiertemp->Pcarreau + ((px - 1) + ((py + ori - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                   echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 1) + ((py + ori - 1) * 8))); // ajout de la case aux prévisions
                   imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                   }
                temppriseenpassant = (piece *)echiquiertemp->dernierpion; // test de possibilité de la prise en passant
                if (temppriseenpassant != NULL)
                   { // on teste la technique de la prise en passant
                   echec = echiquiertemp->EstEchec(px, py, px + 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                   if (echec == 0 && temppriseenpassant->PositionX() == (px + 1) && temppriseenpassant->PositionY() == py && temppriseenpassant->Couleur() != couleur)
                      {
                      imagetemp = (echiquiertemp->Pcarreau + (px + ((py + ori - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                      echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + (px + ((py + ori - 1) * 8))); // ajout de la case aux prévisions
                      imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                      imagetemp = (echiquiertemp->Pcarreau + ((temppriseenpassant->PositionX() - 1) + ((temppriseenpassant->PositionY() - 1) * 8)))->Image(); // Prise en compte de la pièce à manger en passant
                      echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((temppriseenpassant->PositionX() - 1) + ((temppriseenpassant->PositionY() - 1) * 8))); // ajout de la case aux prévisions
                      imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelectRouge.png"); // change la couleur de la case
                      }
                   echec = echiquiertemp->EstEchec(px, py, px - 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                   if (echec == 0 && temppriseenpassant->PositionX() == (px - 1) && temppriseenpassant->PositionY() == py && temppriseenpassant->Couleur() != couleur)
                      {
                      imagetemp = (echiquiertemp->Pcarreau + ((px - 2) + ((py + ori - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                      echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 2) + ((py + ori - 1) * 8))); // ajout de la case aux prévisions
                      imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                      imagetemp = (echiquiertemp->Pcarreau + ((temppriseenpassant->PositionX() - 1) + ((temppriseenpassant->PositionY() - 1) * 8)))->Image(); // Prise en compte de la pièce à manger en passant
                      echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((temppriseenpassant->PositionX() - 1) + ((temppriseenpassant->PositionY() - 1) * 8))); // ajout de la case aux prévisions
                      imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelectRouge.png"); // change la couleur de la case
                      }
                   }
                if (px != 8)
                   {
                   temppiece = (piece *)(echiquiertemp->Pcarreau + (px + ((py + ori - 1) * 8)))->Piece();
                   if (temppiece != NULL)
                      {
                      testactif = true;
                      }
                   else {
                        testactif = false;
                        }
                   if (testactif == true)
                      {
                      echec = echiquiertemp->EstEchec(px, py, px + 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                      if (echec == 0 && temppiece->Couleur() != couleur)
                         {
                         imagetemp = (echiquiertemp->Pcarreau + (px + ((py + ori - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                         echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + (px + ((py + ori - 1) * 8))); // ajout de la case aux prévisions
                         imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                         }
                      }
                   }
                if (px != 1)
                   {
                   temppiece = (piece *)(echiquiertemp->Pcarreau + (px - 2 + ((py + ori - 1) * 8)))->Piece();
                   if (temppiece != NULL)
                      {
                      testactif = true;
                      }
                   else {
                        testactif = false;
                        }
                   if (testactif == true)
                      {
                      echec = echiquiertemp->EstEchec(px, py, px - 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                      if (echec == 0 && temppiece->Couleur() != couleur)
                         {
                         imagetemp = (echiquiertemp->Pcarreau + ((px - 2) + ((py + ori - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                         echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 2) + ((py + ori - 1) * 8))); // ajout de la case aux prévisions
                         imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                         }
                      }
                   }
                break;
       case 2 : // prévision pour un cavalier
                for (int i = 0; i < 8; i++)
                    {
                    int x, y;
                    switch (i)
                           {
                           case 0 : x=px-2; y=py+1; break;
                           case 1 : x=px-2; y=py-1; break;
                           case 2 : x=px+2; y=py+1; break;
                           case 3 : x=px+2; y=py-1; break;
                           case 4 : x=px+1; y=py-2; break;
                           case 5 : x=px-1; y=py-2; break;
                           case 6 : x=px+1; y=py+2; break;
                           case 7 : x=px-1; y=py+2; break;
                           default: ;
                           }
                    if (x >= 1 && x <= 8 && y >= 1 && y <= 8)
                       {
                       carreautemp = echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8));
                       temppiece = (piece *)carreautemp->Piece();
                       echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                       if (echec == 0)
                          {
                          if (temppiece != NULL)
                             {
                             if (temppiece->Couleur() != couleur)
                                {
                                imagetemp = carreautemp->Image();
                                echiquiertemp->Prevision->Add(carreautemp); // ajout de la case aux prévisions
                                imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                                }
                             }
                          else {
                               imagetemp = carreautemp->Image();
                               echiquiertemp->Prevision->Add(carreautemp); // ajout de la case aux prévisions
                               imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                               }
                          }
                       }
                    }
                break;
       case 3 : // prévision pour une tour
                for (int i = 1; px + i <= 8; i++) // parcours de toutes les cases vers la droite
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; px + i >= 1; i--) // parcours de toutes les cases vers la gauche
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; py + i <= 8; i++) // parcours de toutes les cases vers le haut
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; py + i >= 1; i--) // parcours de toutes les cases vers le bas
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencontré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                break;
       case 4 : // prévision pour un fou
                for (int i = 1; px + i <= 8 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute droite
                    {
                    int x = px + i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencontré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1;  px + i <= 8 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse droite
                    {
                    int x = px + i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencontré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px - i >= 1 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute gauche
                    {
                    int x = px - i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencontré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px - i >= 1 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse gauche
                    {
                    int x = px - i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencontré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                break;
       case 5 : // prévision pour une reine qui correspond à une tour + un fou
				for (int i = 1; px + i <= 8; i++) // parcours de toutes les cases vers la droite
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; px + i >= 1; i--) // parcours de toutes les cases vers la gauche
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((py - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }

                for (int i = 1; py + i <= 8; i++) // parcours de toutes les cases vers le haut
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; py + i >= 1; i--) // parcours de toutes les cases vers le bas
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((px - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px + i <= 8 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute droite
                    {
                    int x = px + i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1;  px + i <= 8 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse droite
                    {
                    int x = px + i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px - i >= 1 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute gauche
                    {
                    int x = px - i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px - i >= 1 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse gauche
                    {
                    int x = px - i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                       echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                       imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                break;
       case 6 : // prévision pour un roi
                for (int i = -1; i <= 1; i++)
                    {
                    for (int j = -1; j <= 1; j++)
                        {
                        int x = px + i;
                        int y = py + j;
                        if (x != 0 && y != 0 && x <= 8 && x >= 1 && y <= 8 && y >= 1 && !(x == px && y == py))
                           {
                           echec = echiquiertemp->CaseEchec(x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                           piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                           if (echec == 0)
                              {
                              testactif = false;
                              if (temppiece == NULL)
                                 {
                                 testactif = true;
                                 }
                              else {
                                   if (temppiece->Couleur() != Couleur())
                                      {
                                      testactif = true;
                                      }
                                   }
                              }
                           else {
                                testactif = false;
                                }
                           if (testactif == true)
                              {
                              imagetemp = (echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                              echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8))); // ajout de la case aux prévisions
                              imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                              }
                           }
                        }
                    }
                if (((roi *)this)->roc == 0)
                   {
                   tour *tour1 = (tour *)(echiquiertemp->Pcarreau + (1 - 1 + ((posy - 1) * 8)))->Piece();
                   tour *tour2 = (tour *)(echiquiertemp->Pcarreau + (8 - 1 + ((posy - 1) * 8)))->Piece();
                   if (echiquiertemp->EstEchec(Couleur()) == 0)
                      {
                      if (tour1 != NULL)
                         {
                         if (tour1->roc == 0)
                            {
                            if (echiquiertemp->EstEchec(posx - 1, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 - 1 + ((posy - 1) * 8)))->Piece() == NULL)
                               {
                               if (echiquiertemp->EstEchec(posx - 2, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 - 2 + ((posy - 1) * 8)))->Piece() == NULL)
                                  {
                                  if (ScanRoc(tour1) == 1)
                                     {
                                     imagetemp = (echiquiertemp->Pcarreau + ((posx - 1 - 2) + ((posy - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                                     echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((posx - 1 - 2) + ((posy - 1) * 8))); // ajout de la case aux prévisions
                                     imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                                     }
                                  }
                               }
                            }
                         }
                       if (tour2 != NULL)
                         {
                         if (tour2->roc == 0)
                            {
                            if (echiquiertemp->EstEchec(posx + 1, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 + 1 + ((posy - 1) * 8)))->Piece() == NULL)
                               {
                               if (echiquiertemp->EstEchec(posx + 2, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 + 2 + ((posy - 1) * 8)))->Piece() == NULL)
                                  {
                                  if (ScanRoc(tour2) == 1)
                                     {
                                     imagetemp = (echiquiertemp->Pcarreau + ((posx - 1 + 2) + ((posy - 1) * 8)))->Image(); // Prise en compte de la 1ère case
                                     echiquiertemp->Prevision->Add(echiquiertemp->Pcarreau + ((posx - 1 + 2) + ((posy - 1) * 8))); // ajout de la case aux prévisions
                                     imagetemp->Picture->LoadFromFile(ExtractFilePath(Application->ExeName) + "CarreauSelect.png"); // change la couleur de la case
                                     }
                                  }
                               }
                            }
                         }
                      }
                   }
                break;
       default:
       ;
       }
Form1->Label1->Caption = "x = " + IntToStr(px) + " et Y = " + IntToStr(py) + " et total = " + IntToStr(px-1+(py-1)*8);
}
//---------------------------------------------------------------------------
bool __fastcall piece::ScanRoc(piece *temppiece)
{
tour *temptour = (tour *)temppiece;
Echiquier *echiquiertemp = (Echiquier *)PEchiquier;
int i;
if ((temptour->PositionX() - posx) > 0)
   {i = -1;}
else {i = 1;}
while (i != -(temptour->PositionX() - posx - 1) && i != -(temptour->PositionX() - posx + 1))
      {
      if ((echiquiertemp->Pcarreau + (temptour->PositionX() - 1 + i + ((posy - 1) * 8)))->Piece() != NULL)
         {
         return 0;
         }
      if ((temptour->PositionX() - posx) > 0)
         {i--;}
      else {i++;}
      }
return 1;
}
//---------------------------------------------------------------------------
bool __fastcall Echiquier::DeplacementPossible(int couleur)
{
pion *temppion;
cavalier *tempcavalier;
tour *temptour;
fou *tempfou;
reine *tempreine;
roi *temproi;
roi *temproi2;
carreau * tempcarreau;
for (int i = 0; i < 2; i++)
    {
    temproi2 = (roi *)(Proi + i);
    if (temproi2->Couleur() == couleur)
       {
       if (temproi2->Test())
          {
          return 1;
          }
       }
    }
for (int i = 0; i < 16; i++)
    {
    temppion = (pion *)(Ppion + i);
    if (temppion != NULL)
       {
       if (temppion->Actif() == true)
		  {
		  if (temppion->Couleur() == couleur)
             {
             if (temppion->Test())
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbcavalier; i++)
    {
    tempcavalier = (cavalier *)(Pcavalier + i);
    if (tempcavalier != NULL)
       {
       if (tempcavalier->Actif() == true)
		  {
		  if (tempcavalier->Couleur() == couleur)
			 {

             if (tempcavalier->Test())
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbtour; i++)
    {
    temptour = (tour *)(Ptour + i);
    if (temptour != NULL)
       {
       if (temptour->Actif() == true)
          {
		  if (temptour->Couleur() == couleur)
			 {
             if (temptour->Test())
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbfou; i++)
    {
    tempfou = (fou *)(Pfou + i);
    if (tempfou != NULL)
       {
       if (tempfou->Actif() == true)
          {
		  if (tempfou->Couleur() == couleur)
             {
             if (tempfou->Test())
                {
                return 1;
                }
             }
          }
       }
    }
for (int i = 0; i < Nbreine; i++)
    {
    tempreine = (reine *)(Preine + i);
    if (tempreine != NULL)
	   {
	   if (tempreine->Actif() == true)
		  {
		  if (tempreine->Couleur() == couleur)
			 {
             if (tempreine->Test())
                {
                return 1;
                }
             }
          }
       }
    }
return 0;
}
//---------------------------------------------------------------------------
bool __fastcall piece::Test()
{
int typepiece, px, py;
piece *piecetemp = this;
Echiquier *echiquiertemp = (Echiquier *)PEchiquier;
typepiece = piecetemp->Type();
px = piecetemp->PositionX();
py = piecetemp->PositionY();
piece *temppriseenpassant;
carreau *carreautemp;
piece *temppiece;
bool echec, testactif;
int ori; //déduction de l'orientation du déplacement en fonction du sens et de la couleur
if (couleur == blanc) // on s'en sert comme multiplicateur pour ajouter ou soustraire.
   {
   if (echiquiertemp->sens == 0)
      {
      ori = 1;
      }
   else {
        ori = -1;
        }
   }
else {
     if (echiquiertemp->sens == 0)
        {
        ori = -1;
        }
     else {
          ori = 1;
          }
     }
switch (typepiece)
       {
       //1=pion, 2=cavalier, 3=tour, 4=fou, 5=reine, 6=roi
       case 1 : // prévision pour un pion
                if (Deplacement() == 0)
                   {
                   temppiece = (piece *)((echiquiertemp->Pcarreau + ((px - 1) + ((py + (2 * ori) - 1) * 8)))->Piece());
                   echec = echiquiertemp->EstEchec(px, py, px, py + (2 * ori), couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                   if (echec == 0 && ((echiquiertemp->Pcarreau + ((px - 1) + ((py + ori - 1) * 8)))->Piece() == NULL) && temppiece == NULL)
                      { // avance de 2 cases du pion
                      return 1;
                      }
                   }
				echec = echiquiertemp->EstEchec(px, py, px, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                if (echec == 0 && ((echiquiertemp->Pcarreau + ((px - 1) + ((py + ori - 1) * 8)))->Piece() == NULL))
                   { // avance d'une case du pion
                   return 1;
                   }
                temppriseenpassant = (piece *)echiquiertemp->dernierpion; // test de possibilité de la prise en passant
                if (temppriseenpassant != NULL)
                   { // on teste la technique de la prise en passant
                   echec = echiquiertemp->EstEchec(px, py, px + 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                   if (echec == 0 && temppriseenpassant->PositionX() == (px + 1) && temppriseenpassant->PositionY() == py && temppriseenpassant->Couleur() != couleur)
                      {
                      return 1;
                      }
                   echec = echiquiertemp->EstEchec(px, py, px - 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                   if (echec == 0 && temppriseenpassant->PositionX() == (px - 1) && temppriseenpassant->PositionY() == py && temppriseenpassant->Couleur() != couleur)
                      {
                      return 1;
                      }
                   }
                if (px != 8)
                   {
                   temppiece = (piece *)(echiquiertemp->Pcarreau + (px + ((py + ori - 1) * 8)))->Piece();
                   if (temppiece != NULL)
                      {
                      testactif = true;
                      }
                   else {
                        testactif = false;
                        }
                   if (testactif == true)
                      {
                      echec = echiquiertemp->EstEchec(px, py, px + 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                      if (echec == 0 && temppiece->Couleur() != couleur)
                         {
                         return 1;
                         }
                      }
                   }
                if (px != 1)
                   {
                   temppiece = (piece *)(echiquiertemp->Pcarreau + (px - 2 + ((py + ori - 1) * 8)))->Piece();
                   if (temppiece != NULL)
                      {
                      testactif = true;
                      }
                   else {
                        testactif = false;
                        }
                   if (testactif == true)
                      {
                      echec = echiquiertemp->EstEchec(px, py, px - 1, py + ori, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                      if (echec == 0 && temppiece->Couleur() != couleur)
                         {
                         return 1;
                         }
                      }
                   }
                break;
       case 2 : // prévision pour un cavalier
                for (int i = 0; i < 8; i++)
                    {
                    int x, y;
                    switch (i)
                           {
                           case 0 : x=px-2; y=py+1; break;
                           case 1 : x=px-2; y=py-1; break;
                           case 2 : x=px+2; y=py+1; break;
                           case 3 : x=px+2; y=py-1; break;
                           case 4 : x=px+1; y=py-2; break;
                           case 5 : x=px-1; y=py-2; break;
                           case 6 : x=px+1; y=py+2; break;
                           case 7 : x=px-1; y=py+2; break;
                           default: ;
                           }
                    if (x >= 1 && x <= 8 && y >= 1 && y <= 8)
                       {
                       carreautemp = echiquiertemp->Pcarreau + ((x - 1) + ((y - 1) * 8));
                       temppiece = (piece *)carreautemp->Piece();
                       echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                       if (echec == 0)
                          {
                          if (temppiece != NULL)
                             {
                             if (temppiece->Couleur() != couleur)
                                {
                                return 1;
                                }
                             }
                          else {
                               return 1;
                               }
                          }
                       }
                    }
                break;
       case 3 : // prévision pour une tour
                for (int i = 1; px + i <= 8; i++) // parcours de toutes les cases vers la droite
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; px + i >= 1; i--) // parcours de toutes les cases vers la gauche
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; py + i <= 8; i++) // parcours de toutes les cases vers le haut
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; py + i >= 1; i--) // parcours de toutes les cases vers le bas
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                break;
       case 4 : // prévision pour un fou
                for (int i = 1; px + i <= 8 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute droite
                    {
                    int x = px + i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1;  px + i <= 8 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse droite
                    {
                    int x = px + i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }

                for (int i = 1; px - i >= 1 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute gauche
                    {
                    int x = px - i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px - i >= 1 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse gauche
                    {
                    int x = px - i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                break;
       case 5 : // prévision pour une reine qui correspond à une tour + un fou
				for (int i = 1; px + i <= 8; i++) // parcours de toutes les cases vers la droite
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; px + i >= 1; i--) // parcours de toutes les cases vers la gauche
                    {
                    int x = px + i;
                    echec = echiquiertemp->EstEchec(px, py, x, py, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((py - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }

                for (int i = 1; py + i <= 8; i++) // parcours de toutes les cases vers le haut
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = -1; py + i >= 1; i--) // parcours de toutes les cases vers le bas
                    {
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, px, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (px - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px + i <= 8 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute droite
                    {
                    int x = px + i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1;  px + i <= 8 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse droite
                    {
                    int x = px + i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px - i >= 1 && py + i <= 8; i++) // parcours de toutes les cases vers la diagonale haute gauche
                    {
                    int x = px - i;
                    int y = py + i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                for (int i = 1; px - i >= 1 && py - i >= 1; i++) // parcours de toutes les cases vers la diagonale basse gauche
                    {
                    int x = px - i;
                    int y = py - i;
                    echec = echiquiertemp->EstEchec(px, py, x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                    piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                    if (echec == 0)
                       {
                       if (temppiece == NULL)
                          {
                          testactif = true;
                          }
                       else {
                            if (temppiece->Couleur() == Couleur())
                               {
                               break; // on ne peut colorier cette case puisqu'il y a une pièce de la même couleur
                               }
                            testactif = false; // on arrête de parcourir puisque l'on a rencon,tré une pièce
                            }
                       return 1;
                       }
                    else {
                         if (temppiece != NULL)
                            {
                            testactif = false;
                            }
                         }
                    if (testactif == false)
                       {
                       break;
                       }
                    }
                break;
       case 6 : // prévision pour un roi
                for (int i = -1; i <= 1; i++)
                    {
                    for (int j = -1; j <= 1; j++)
                        {
                        int x = px + i;
                        int y = py + j;
                        if (x != 0 && y != 0 && x <= 8 && x >= 1 && y <= 8 && y >= 1 && !(x == px && y == py))
                           {
                           echec = echiquiertemp->CaseEchec(x, y, couleur); // vérifie si l'avance du pion ne provoque pas d'échec
                           piece *temppiece = (piece *)((echiquiertemp->Pcarreau + (x - 1 + ((y - 1) * 8)))->Piece());
                           if (echec == 0)
                              {
                              testactif = false;
                              if (temppiece == NULL)
                                 {
                                 testactif = true;
                                 }
                              else {
                                   if (temppiece->Couleur() != Couleur())
                                      {
                                      testactif = true;
                                      }
                                   }
                              }
                           else {
                                testactif = false;
                                }
                           if (testactif == true)
                              {
                              return 1;
                              }
                           }
                        }
                    }
                if (((roi *)this)->roc == 0)
                   {
                   tour *tour1 = (tour *)(echiquiertemp->Pcarreau + (1 - 1 + ((posy - 1) * 8)))->Piece();
                   tour *tour2 = (tour *)(echiquiertemp->Pcarreau + (8 - 1 + ((posy - 1) * 8)))->Piece();
                   if (echiquiertemp->EstEchec(Couleur()) == 0)
                      {
                      if (tour1 != NULL)
                         {
                         if (tour1->roc == 0)
                            {
                            if (echiquiertemp->EstEchec(posx - 1, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 - 1 + ((posy - 1) * 8)))->Piece() == NULL)
                               {
                               if (echiquiertemp->EstEchec(posx - 2, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 - 2 + ((posy - 1) * 8)))->Piece() == NULL)
                                  {
                                  if (ScanRoc(tour1) == 1)
                                     {
                                     return 1;
                                     }
                                  }
                               }
                            }
                         }
                       if (tour2 != NULL)
                         {
                         if (tour2->roc == 0)
                            {
                            if (echiquiertemp->EstEchec(posx + 1, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 + 1 + ((posy - 1) * 8)))->Piece() == NULL)
                               {
                               if (echiquiertemp->EstEchec(posx + 2, posy, Couleur()) == 0 && (echiquiertemp->Pcarreau + (posx - 1 + 2 + ((posy - 1) * 8)))->Piece() == NULL)
                                  {
                                  if (ScanRoc(tour2) == 1)
                                     {
                                     return 1;
                                     }
                                  }
                               }
                            }
                         }
                      }
                   }
                break;
       default:
       ;
       }
return 0;
}
//---------------------------------------------------------------------------

